// SI008View.cpp : implementation of the CSI008View class
//

#include "stdafx.h"
#include "SI008.h"

#include "SI008Doc.h"
#include "SI008View.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CSI008View

IMPLEMENT_DYNCREATE(CSI008View, CView)

BEGIN_MESSAGE_MAP(CSI008View, CView)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

// CSI008View construction/destruction

CSI008View::CSI008View()
{
}

CSI008View::~CSI008View()
{
}

BOOL CSI008View::PreCreateWindow(CREATESTRUCT& cs)
{
	return CView::PreCreateWindow(cs);
}

// CSI008View drawing

void CSI008View::OnDraw(CDC* /*pDC*/)
{
	CSI008Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: add draw code for native data here
}


// CSI008View printing

BOOL CSI008View::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CSI008View::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CSI008View::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}


// CSI008View diagnostics

#ifdef _DEBUG
void CSI008View::AssertValid() const
{
	CView::AssertValid();
}

void CSI008View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CSI008Doc* CSI008View::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSI008Doc)));
	return (CSI008Doc*)m_pDocument;
}
#endif //_DEBUG


void CSI008View::ShowImage(const SIPackedDIB * pPackedDIB)
{
	CClientDC dc(this);
	
	const BITMAPINFOHEADER & bmi = pPackedDIB->BmpInfo;

	CSI008Doc* pDoc = GetDocument();
	
	int w = bmi.biWidth;
	int h = bmi.biHeight;

	if(h<0) h = -h;

	::StretchDIBits(dc.GetSafeHdc(),		
		0,0,w,h,
		0,0,w,h,
		pPackedDIB->pDIBBits,
		(BITMAPINFO*)(&bmi),
		DIB_RGB_COLORS,SRCCOPY);

	if(pDoc->m_Status == CSI008Doc::Run)
	{
		CString strFrame;
		strFrame.Format("%.8d",pDoc->m_dwFrame);
		dc.SetBkMode(TRANSPARENT);
		dc.SetTextColor(RGB(0,255,0));
		dc.TextOut(10,5,strFrame);
	}
}