// SI004Doc.cpp : implementation of the CSI004Doc class
//

#include "stdafx.h"
#include "SI004.h"
#include "siusb.h"
#include "sidefs.h"
#include <afxwin.h>

SI_RGBC3ToDIB(SIColorImage*,BITMAPINFO * pBmp);
SI_MallocColorImage(SIColorImage* pColor);
//SI_FreeColorImage(SIColorImage* pClrImage);


#include "SI004Doc.h"
#include "SI004View.h"
#include "DialogPar.h"
#include "Dialog1300Settings.h"
#include "Dialog3300Settings.h"
#include "Dialog2100SettingsZ.h"
#include "Dialog5100Settings.h"
#include "Dialog6600Settings.h"
#include "Dialog1280Settings.h"
#include "DialogCameraInfo.h"
#include "DialogDriverDelaySetting2.h"
#include "SetCamera.h"
#include ".\si004doc.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define SI3170 0
#define SI1280 1
#define SI2100 2
#define SI1300 3
#define SI3300 4
#define SI6600 5
#define SI5100 6


/////////////////////////////////////////////////////////////////////////////
// CSI004Doc

IMPLEMENT_DYNCREATE(CSI004Doc, CDocument)

BEGIN_MESSAGE_MAP(CSI004Doc, CDocument)
	//{{AFX_MSG_MAP(CSI004Doc)
	
	
	ON_COMMAND(ID_ACTION_SETTINGS, OnActionSettings)
	ON_UPDATE_COMMAND_UI(ID_ACTION_SETTINGS, OnUpdateActionSettings)
	//}}AFX_MSG_MAP
	
	ON_COMMAND(ID_ACTION_CONFIG, OnActionConfig)
	ON_COMMAND(ID_ACTION_SNAP, OnActionSnap)
	ON_COMMAND(ID_ACTION_LIVESTART, OnActionLiveStart)
	ON_COMMAND(ID_ACTION_SEQUENCEDLIVESTART, OnActionSequencedLiveStart)
	ON_COMMAND(ID_ACTION_STARTSNAPLOOP, OnActionStartSnapLoop)
	ON_COMMAND(ID_ACTION_DISPLAYLIVESEQUENCE, OnActionDisplayLiveSequence)
	
	ON_COMMAND(ID_SI1300_INITIALIZE, OnSI1300Initialize)	
	ON_COMMAND(ID_SI1300_SNAP147, OnSi1300SnapA)
	ON_COMMAND(ID_ACTION_SINGLESNAP, OnActionSingleSnapMono)
	ON_COMMAND(ID_ACTION_STARTDOUBLEBUFFEREDSNAP, OnActionStartDBSnapLoop)
	ON_COMMAND(ID_TESTING_SI, OnTestingSi1300Settings)
	ON_COMMAND(ID_LIVEMODEDISPLAY_ON, OnLiveModeDisplayOn)
	ON_COMMAND(ID_LIVEMODEDISPLAY_OFF, OnLiveModedisplayOff)
	ON_COMMAND(ID_ACTION_STARTSNAPLOOP157, OnActionStartSnapLoopColor)
	ON_COMMAND(ID_SETTINGS_INVALIDCOUNTON, OnSettingsInvalidCountOn)
	ON_COMMAND(ID_SETTINGS_INVALIDCOUNTOFF, OnSettingsInvalidCountOff)
	ON_COMMAND(ID_TESTING_SI162, OnTestingSI1300Settings)
	ON_COMMAND(ID_TESTING_SI165, OnTestingSI2100Settings)
	ON_COMMAND(ID_CAMERA_SI, OnTestingSI3300Settings)
	ON_COMMAND(ID_CAMERA_SI178, OnTestingSI6600Settings)
	ON_COMMAND(ID_CAMERAINFO_FIRMWAREVSERIONANDSERIALNUMBER, GetCameraFirmwareSerialNumber)
	ON_COMMAND(ID_ACTION_SNAP12BITMONOANDSAVE, OnActionSnap12BitMonoSave)
	ON_COMMAND(ID_ACTION_STOPCAPTURE, OnActionStopCapture)
	ON_COMMAND(ID_CAMERA_SI186, OnTestingSI1280Settings)
	ON_COMMAND(ID_PIXELCORRECTION_LIVEMODECORRECTIONON, OnPixelCorrectionOn)
	ON_COMMAND(ID_PIXELCORRECTION_LIVEMODECORRECTINOFF, OnPixelCorrectionOff)
	ON_COMMAND(ID_ACTION_WAITFORTRIGGERANDSINGLESNAP, OnActionArmSnap)
	ON_COMMAND(ID_ACTION_DISARMTRIGGER, OnActionDisarmTrigger)
	ON_COMMAND(ID_ACTION_SETMONOBMPSAVEFILENAME, OnActionSetBMPSaveFilename)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_COMMAND(ID_ACTION_STARTCONTINUOUSLIVE, OnActionLiveStartColor)
	ON_COMMAND(ID_ACTION_STARTCONTINUOUSLIVEASYNCDEMO, OnActionStartLiveAsyncDemo)
	ON_COMMAND(ID_SETTINGS_SETCAMERANUMBER, OnSettingsSetCameraNumber)
	ON_COMMAND(ID_CAMERAREGISTERS_2100REGISTERS, OnRead2100Registers)
	ON_COMMAND(ID_SETTINGS_SETDRIVERDELAY, OnSettingsSetDriverDelay)
	ON_COMMAND(ID_ACTION_TEST, OnActionTestHandle)
	ON_COMMAND(ID_ACTION_STARTTRIGGEREDSNAPLOOP, OnActionStartTriggeredSnapLoop)	
	ON_COMMAND(ID_SETTINGS_AUTOEXPOSUREENABLED, OnSettingsSetAutoexposure)
	ON_COMMAND(ID_SETTINGS_DISPLAYSUBSAMPLINGENABLED, OnSettingsDisplaySubsamplingEnabled)
	ON_COMMAND(ID_CAMERA_SI32796, OnTestingSI5100Settings)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSI004Doc construction/destruction

CSI004Doc::CSI004Doc()
{	

	// TODO: add one-time construction code here

		m_strConfigFile = _T("");
		m_bInitialized = FALSE;	
		m_bDAlreadyAllocated = FALSE;
		m_bBMAlreadyAllocated = FALSE;
		m_bCaptureSequenceBuffer = FALSE;
		m_bTriggeredSnapLoop = FALSE;
		iModePast = 1;	
		m_iCamID = 0;
		pDBuffer2 = 0;
		m_hEvent1 = 0;
		m_hEvent2 = 0;
		m_hEvent3 = 0;
		m_Status = Stop;		
		m_LiveType = 0;
		m_bDisplay = 1;
		m_InvalidShown = 0;
		m_Camera = 0;
		m_bSpecialSettings = FALSE;
		m_Subsampling = 1;
		m_StartColumn = 0;
		m_StartRow = 0;
		m_cGain = "      ";
		m_DPCOn = 1;
		m_ColorMode = 0;
		m_GainMode = 0;
		m_RedGain = 1;
		m_GreenGain = 1;
		m_Green1Gain = 1;
		m_BlueGain = 1;
		m_UpperBrightnessTarget = 0;
		m_LowerBrightnessTarget = 0;
		m_AEControl = 0;
		m_Filename = "C:\\image.bmp";
		m_SaveFlag = FALSE;	
		m_ColorFlag = FALSE;
		m_PanScrollFlag = 0;
		m_DriverDelay = 10;
		m_ShutterMode = 0;
		m_AutoExposure = FALSE;
		m_DisplaySubsamp = 1;
		
}

CSI004Doc::~CSI004Doc()
{
			
}

BOOL CSI004Doc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CSI004Doc serialization

void CSI004Doc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CSI004Doc diagnostics

#ifdef _DEBUG
void CSI004Doc::AssertValid() const
{
	CDocument::AssertValid();
}

void CSI004Doc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG




void CSI004Doc::OnActionStop() 
{
	// TODO: Add your command handler code here
	m_Status = Stop;
	::WaitForSingleObject(m_hSnapThread,INFINITE);
	::CloseHandle(m_hSnapThread);
	
}

void CSI004Doc::OnUpdateActionStop(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(m_Status == Run);
}

void CSI004Doc::UpdateCamera()
{
unsigned char iRegGlobal, iRegRed, iRegBlue, iRegExp, iX;
	
}


void CSI004Doc::OnActionSettings() 
{
	// TODO: Add your command handler code here	
	if (!m_bInitialized)
	{
		AfxMessageBox("Please select the configuration files first (Action | Config) and snap.");
		return;
	}
	if (DialogParam.DoModal() == IDOK)
	{		
	UpdateCamera();
	}
		
}

void CSI004Doc::OnUpdateActionSettings(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	//pCmdUI->Enable(m_Status == Stop);
}



DWORD WINAPI CSI004Doc::LiveThreadFunc(LPVOID pParam)
{
	CSI004Doc * pDoc = static_cast<CSI004Doc*>(pParam);
	int iBytesRead; 
	int sts, iDepth;

	// allocate double buffer	
	if (pDoc->m_Bpp == 8)
		iDepth = 1;
	else 
		iDepth = 2;


	// check for memory already allocated
	if (!pDoc->m_bDAlreadyAllocated)
	{
		int iSize = 2 * iDepth * (pDoc->m_Width * pDoc->m_Height);  
		pDoc->pDBuffer2 = new BYTE[iSize];		
		pDoc->m_bDAlreadyAllocated = TRUE;
	}

	//TRACE("start arming\n");
	//AfxMessageBox("arming trigger and waiting");				
	//SI_ArmTriggerWait(0);
	//TRACE(" trigger disabled\n");
	//SI_SnapBulkImage(0, pDoc->m_Width, pDoc->m_Height, 8, pDoc->pDBuffer2, &iBytesRead);
	//TRACE(" passed read\n");
	//return 0;

	
	
	sts = SI_SnapBulkLiveStart(pDoc->m_iCamID, pDoc->m_Width, pDoc->m_Height, pDoc->m_Bpp, pDoc->pDBuffer2, 
						 0, pDoc->m_hEvent1, pDoc->m_hEvent2, pDoc->m_hEvent3);
	
	
	if (sts != SI_STATUS_SUCCESS)
		AfxMessageBox("continuous capture error\n");
	
	
		
	return 0;
}

DWORD WINAPI CSI004Doc::LiveDisplayThreadFunc(LPVOID pParam)
{
	DWORD dwStart, dwEnd, TimeArray[20], CountArray[20], ret;
	double TotalSecs;
	HANDLE hEventArray[3];
	char mbuf[120];
	SIMonoImage mono;
	SIColorImage sicic3, sicip3;
	int iFirst, iflip, iDepth;
	int poscounter2, inc;
	int xStart, yStart, poscounter, gaincounter;
	PBYTE pB;
	int n, ii;
	unsigned short* pbayer;

	SIPoint dpclist[10000];
		
	CSI004Doc * pDoc = static_cast<CSI004Doc*>(pParam);

	mono.iWidth = pDoc->m_Width;
	mono.iHeight = pDoc->m_Height;
	mono.iPitch = mono.iWidth;
	mono.iBpp = pDoc->m_Bpp;
	mono.Data.pData8u = pDoc->pDBuffer2;

	if (pDoc->m_ColorFlag)
	{
		//sicic3.iWidth = pDoc->m_Width;
		//sicic3.iHeight = pDoc->m_Height;		
		//sicic3.DOrder = Pixel;
		//SI_MallocColorImage(&sicic3);

		//sicip3.iWidth = pDoc->m_Width;
		//sicip3.iHeight = pDoc->m_Height;
		//sicip3.DOrder = Plane;
		//SI_MallocColorImage(&sicip3);
	}

	
	
	//CStatusBar& statusbar = pDoc->pFrame->m_wndStatusBar;	
	//statusbar.SetPaneText(0, "test2");
	//return 0;

	pDoc->m_BadCount = 0;

	hEventArray[0] = pDoc->m_hEvent1;
	hEventArray[1] = pDoc->m_hEvent2;
	hEventArray[2] = pDoc->m_hEvent3;

	//CStatusBar& statusbar = pDoc->pFrame->m_wndStatusBar;
	//TRACE("statusbar in thread: %x\n", statusbar);
	//AfxMessageBox("statusbar passed");
	//statusbar.SetPaneText(0, "test3", TRUE);
	//AfxMessageBox("set pane passed");

	//CStatusBar& statusbar = ((CMainFrame*)AfxGetMainWnd())->m_wndStatusBar;
	//pDoc->statusbar->SetPaneText(0, "test3", TRUE);
	//return 0;
	iDepth = 1;
	if (pDoc->m_Bpp == 12)
		iDepth = 2;
		
	//iSize = iSize * (pDoc->m_Width * pDoc->m_Height);  
		
	pDoc->m_dwFrame = 0;
	pDoc->m_Fps = 0.0;

	

	for (int i= 0;  i < 20; i++)
	{
		TimeArray[i] = 0;
		CountArray[i] = 0;
	}
	
		
	// Prepare the Bitmap data structure for display.
	if (!pDoc->m_bBMAlreadyAllocated)
	{
		pDoc->m_pBmi = (BITMAPINFOHEADER*)(new BYTE[sizeof(BITMAPINFOHEADER) + 256*sizeof(RGBQUAD)]);
		ZeroMemory(pDoc->m_pBmi,sizeof(BITMAPINFOHEADER));
		pDoc->m_pBmi->biSize				= sizeof(BITMAPINFOHEADER);
		pDoc->m_pBmi->biWidth				= pDoc->m_Width;
		pDoc->m_pBmi->biHeight				= pDoc->m_Height;
		pDoc->m_pBmi->biPlanes				= 1;
		pDoc->m_pBmi->biBitCount			= 8;			
		pDoc->m_pBmi->biCompression	= BI_RGB;
		pDoc->m_bBMAlreadyAllocated = 1;
	}

	RGBQUAD * pQuad = (RGBQUAD*)(reinterpret_cast<BYTE*>(pDoc->m_pBmi) + sizeof(BITMAPINFOHEADER));	

	for(int i=0; i<256; i++)
	{
		pQuad->rgbBlue = pQuad->rgbGreen = pQuad->rgbRed = i;
		pQuad->rgbReserved = 0;
		pQuad++;
	}

	// display images from double buffer
	int iBuffer;
	POSITION pos = pDoc-> GetFirstViewPosition();
	if (pos != NULL)
	{			
		CView* pView = pDoc->GetNextView(pos);
		iBuffer = 0;

		iFirst = 1;
		
		poscounter = 0;
		gaincounter = 0;
		
		inc = 1;
		xStart = pDoc->m_StartColumn;
		yStart = pDoc->m_StartRow;
		
		while (!pDoc->m_bStopLiveFlag)
		{	
			// wait for appropriate capture to be completed
			
			ret = WaitForMultipleObjects(3, hEventArray, FALSE, 20000);
			TRACE("event: %d \n",ret - WAIT_OBJECT_0 );
			if (pDoc->m_PanScrollFlag)
			{
				gaincounter++;
				SI_SetGlobalGainB(pDoc->m_iCamID, (gaincounter + 3)/3);
				if (gaincounter == 10)
				{
					gaincounter = 1;
					SI_SetGlobalGainB(pDoc->m_iCamID, gaincounter);
								
				}

				poscounter++;
				xStart = poscounter * inc;
				yStart = poscounter * inc;
				SI_SetStartRow(pDoc->m_iCamID, yStart);
				SI_SetStartColumn(pDoc->m_iCamID, xStart);

				


				if (poscounter == 20)
				{			
					poscounter = 0;			
				
					if (inc == 0)
						inc = 2;
					else
						inc = 12;					
				}
			}

						
			if ((ret - WAIT_OBJECT_0) == 0)
			{
				iBuffer = 0;				
			}
			else if ((ret - WAIT_OBJECT_0) == 1)
			{
				iBuffer = 1;				
			}

			//TRACE("color flag: %d\n", pDoc->m_ColorFlag);
			if (pDoc->m_Bpp == 12) // && !pDoc->m_ColorFlag)
			{
				//TRACE("12 bit conversion\n");
				pB = pDoc->pDBuffer2 + iBuffer * iDepth* (pDoc->m_Width * pDoc->m_Height);
				pbayer = (unsigned short*)pB;
				n = pDoc->m_Width * pDoc->m_Height;
						
				for (int ii = 0; ii < n; ii++)
					{
					//if (ii > n/2 && ii < (n/2 + 20))
					//	TRACE("ii: %d *pbayer: %x\n", ii, *pbayer);

					if (*pbayer > 4095)
						{
							//TRACE("i: %d *pbayer: %x\n",i, *pbayer);
							*pbayer = 4095;
						}
					else
						*pbayer = pDoc->m_lut[*pbayer];

					pbayer++;
						}

				// pick out the 8 bits for display										
				for (int j = 0; j < n; j++)
						{							
						pB[j] = (pB[2 * j + 1] << 4) | (pB[2 * j] >> 4);							
						}
				}
			
			pDoc->m_dwFrame++;
			
			if (pDoc->m_DPCOn) // && pDoc->m_Bpp == 8)
			{
				if (iFirst)
					{
					iFirst = 0;
					mono.Data.pData8u = pDoc->pDBuffer2 + iBuffer * iDepth *(pDoc->m_Width * pDoc->m_Height);
					SI_DeviantPixelDetection(&mono,SIDPC_CSSAD,&(pDoc->m_DPCNum), dpclist, pDoc->m_DPCNum);
					
					}
				if (pDoc->m_dwFrame > 1)
				{					
					mono.Data.pData8u = pDoc->pDBuffer2 + iBuffer * iDepth *(pDoc->m_Width * pDoc->m_Height);
					SI_DeviantPixelCorrection(&mono, pDoc->m_DPCNum,dpclist);					
				}
			}

			// update timer variables	
			dwEnd = GetTickCount();
			TotalSecs = ((double)(dwEnd - TimeArray[0]))/1000.0;
			if (pDoc->m_dwFrame > 20)
				pDoc->m_Fps = (1.0 *(pDoc->m_dwFrame - CountArray[0]))/TotalSecs;

			for (int i = 0; i < 19; i++)
			{
				CountArray[i] = CountArray[i + 1];
				TimeArray[i] = TimeArray[i + 1];
			}
			CountArray[19] = pDoc->m_dwFrame;
			TimeArray[19] = dwEnd;
			
			//TRACE("display flag: %d  debug flag %d   ret:  %d\n", pDoc->m_bDisplay,pDoc->m_InvalidShown, ret);

			if (pDoc->m_ColorFlag)
			{
				//SI_BayerToRGBP3(&mono, &sicip3, SIBayerPhaseBG, SIBayerInterpNNP);
				//SI_RGBP3ToC3(&sicip3, &sicic3);
				//SI_RGBC3ToDIB(&sicic3, (BITMAPINFO*)pDoc->m_pBmi);
			}
						

			if ((ret - WAIT_OBJECT_0) != 2)	
			{
				if (pDoc->m_AutoExposure && iDepth == 1)
					SI_SetAutoExposure(pDoc->m_iCamID, pDoc->m_Width, pDoc->m_Height,
					pDoc->pDBuffer2 + iBuffer * iDepth* (pDoc->m_Width * pDoc->m_Height));


				if (pDoc->m_bDisplay )
				{
					//TRACE("color flag: %d,   pDoc->m_Bpp: %d\n", pDoc->m_ColorFlag,   pDoc->m_Bpp);
					if (pDoc->m_ColorFlag)
					{
						
						//pDoc->ShowImage(const BITMAPINFO * pPackedDIB);
					}
					else
					{	
						if (pDoc->m_Bpp == 12)
							((CSI004View*)pView)->Display(reinterpret_cast<BITMAPINFO*>(pDoc->m_pBmi),pDoc->pDBuffer2 + iBuffer * iDepth* (pDoc->m_Width * pDoc->m_Height));
						else
						{
							memcpy(pDoc->m_image.buffer(), pDoc->pDBuffer2 + iBuffer * iDepth * (pDoc->m_Width * pDoc->m_Height), iDepth * pDoc->m_Width * pDoc->m_Height);
							((CSI004View*)pView)->Display(pDoc->m_image);		
										
						}
					}					
				}

				//sprintf(mbuf, "Image count: %d  Frames per second:  %f", pDoc->m_dwFrame, pDoc->m_Fps);
				//statusbar.SetPaneText(0, mbuf, TRUE);
			}
			else 
			{				
				pDoc->m_BadCount++;	
				
				if (!pDoc->m_bDisplay )
				{					
					int iBuf2;
					if (iBuffer)
						iBuf2 = 0;
					else
						iBuf2 = 1;
					if (pDoc->m_InvalidShown)
					{
					((CSI004View*)pView)->Display(reinterpret_cast<BITMAPINFO*>(pDoc->m_pBmi),pDoc->pDBuffer2 + iBuf2 * iDepth * (pDoc->m_Width * pDoc->m_Height));
							
					}
					
				}
			}

	if (!iBuffer)
		iBuffer = 1;
	else
		iBuffer = 0;
			
	}
		
	
	if (!iBuffer)
		iBuffer = 1;
	else
		iBuffer = 0;
	

	Sleep(200);
	((CSI004View*)pView)->Display(reinterpret_cast<BITMAPINFO*>(pDoc->m_pBmi),pDoc->pDBuffer2 + iBuffer * iDepth * (pDoc->m_Width * pDoc->m_Height));
	//((CSI004View*)pView)->Display(reinterpret_cast<BITMAPINFO*>(pDoc->m_pBmi),pDBuffer3 + iBuffer * (pDoc->m_Width * pDoc->m_Height));

	}

	pDoc->m_PanScrollFlag = 0;
	
	
	delete [] pDoc->pDBuffer2;
	pDoc->m_bDAlreadyAllocated = 0;
	delete [] pDoc->m_pBmi;
	pDoc->m_bBMAlreadyAllocated = 0;

	//if (pDoc->m_Bpp == 12)
	//	SI_FreeColorImage(&sicic3);


	return 0;
}

void CSI004Doc::EndCapture()
{
	
	if(!m_bInitialized) return;

	
	// De-initialized the capture module
	SI_EndCapture(&m_CaptureContext);
	
	
}

void CSI004Doc::OnActionConfig()
{
	//AfxMessageBox("in configure read");
	TCHAR szFilters[] = _T("Config files (*.cfg)|*.cfg|All files(*.*)|*.*||");
	CFileDialog  cfdlg(TRUE, _T("cfg"), _T("*.cfg"), OFN_FILEMUSTEXIST|OFN_HIDEREADONLY|OFN_EXPLORER, szFilters, NULL);	
	if (IDOK == cfdlg.DoModal())
	{
		m_strConfigFile = cfdlg.GetPathName();
		m_bInitialized = FALSE;
		m_bSpecialSettings = FALSE;
	}
}

void CSI004Doc::OnActionSnap()
{	
	if (m_LiveType != 0)
		return;
	if(!InitCapture()) return;
	

	
	if (m_bSpecialSettings)
		SetSpecialSettings();
	TRACE("color size: %d %d\n", m_Width, m_Height);
	//m_Config.CameraConfig.CAMIFFormat.iWidth = m_Width;
	//m_Config.CameraConfig.CAMIFFormat.iHeight = m_Height;
	//m_Config.CameraConfig.CAMIFFormat.iHeight = m_Bpp;


	
	//InitCapture();
	TRACE("Width, height, WidthStart, HeightStart: %d %d %d %d\n", m_Width, m_Height, m_WidthStart, m_HeightStart);
	
	//if (m_CamIdent == SI1280 || m_CamIdent == SI6600)
	//	SI_InitWindowMode(m_iCamID, m_StartRow/m_Subsampling, m_HeightStart/m_Subsampling - 1 + m_StartRow/m_Subsampling, m_StartColumn/m_Subsampling, 
	//		m_WidthStart/m_Subsampling - 1 + m_StartColumn/m_Subsampling, 0, m_ExposureTime);	

	//else
	//	SI_InitWindowMode(m_iCamID, m_StartRow, m_HeightStart - 1 + m_StartRow, m_StartColumn, m_WidthStart - 1 + m_StartColumn, 0, m_ExposureTime);	

	//SI_SetClockB(m_iCamID, m_ClockIndex);
		
	SI_CaptureDIB(&m_CaptureContext);
	m_dwFrame = 0;		
    m_Fps = 0;
	m_BadCount = 0;

	// Return data pPackedDIBis a pointer to a packed DIB buffer (DIB bits following the header immediately)
	if (&m_CaptureContext.PackedDIB)
		ShowImage((const SIPackedDIB *)&m_CaptureContext.PackedDIB);
	
	
}


BOOL CSI004Doc::InitCapture()
{

	//char pcDriverName[8]   = "Ezusb-0";
	
	//int ret = SI_OpenCamera(m_iCamID, pcDriverName);

	//if (ret != SI_STATUS_SUCCESS)
	//	AfxMessageBox("open failed");

	if(m_bInitialized) return TRUE;
	TRACE("filename: %s\n", m_strConfigFile);
	
	// Load the camera configuration
	if(m_strConfigFile == _T(""))
	{
		AfxMessageBox("Please select the configuration files first (Action | Config).");
		return FALSE;
	}

	OnGetCameraType();
	
	SI_ReadConfig(m_strConfigFile,&m_Config, m_CamIdent);
	m_CaptureContext.iCameraID = m_iCamID;

	for (int i=0; i < 4096; i++)
			m_lut[i] = ((i>>8) & 0x0f) | (((short)(i&0xff))<<4);
	
	
	
	if (!m_bSpecialSettings)
	{
		m_Width = m_Config.CameraConfig.CAMIFFormat.iWidth;
		m_Height = m_Config.CameraConfig.CAMIFFormat.iHeight;
		m_Bpp = m_Config.CameraConfig.CAMIFFormat.iBpp;	
		m_Subsampling = m_Config.CameraConfig.CAMIFFormat.iSubSampleMode;
		TRACE("init values: width, height, bpp: %d %d %d\n", m_Width, m_Height, m_Bpp);
		//if (m_Bpp == 8)
		m_ColorMode = 0;
		//else 
		//	m_ColorMode = 1;
		m_ClockIndex = m_Config.CameraConfig.iClockIndex;
		m_GlobalGain = m_Config.CameraConfig.iGlobalGain;	
		m_RedGain = m_Config.CameraConfig.iRGGBGain[0];
		m_GreenGain = m_Config.CameraConfig.iRGGBGain[1];
		m_Green1Gain = m_Config.CameraConfig.iRGGBGain[2];
		m_BlueGain = m_Config.CameraConfig.iRGGBGain[3];
		TRACE("blue gain: %d\n", m_BlueGain);
		m_ExposureTime = m_Config.CameraConfig.iExposureValue;	
		TRACE("clock: %d  exposure: %d\n", m_ClockIndex, m_ExposureTime);
		m_BlackLevel = m_Config.CameraConfig.iBlackOffset;
		m_ColumnOffset = m_Config.CameraConfig.iColumnOffset;	
		m_HeightStart = m_Height;
		m_WidthStart = m_Width;
		m_StartRow = m_Config.CameraConfig.CAMIFFormat.Origin.iY;
		m_StartColumn = m_Config.CameraConfig.CAMIFFormat.Origin.iX;
		m_TBRange = m_Config.CameraConfig.iTBRange;
		m_VerticalBlanking = m_Config.CameraConfig.iVerticalBlanking;
		m_HorizontalBlanking = m_Config.CameraConfig.iVerticalBlanking;
		m_DPCNum = m_Config.ImagingConfig.iMaxDPNum;	
		if (m_DPCNum > 10000) 
			m_DPCNum = 10000;
		m_ShutterDelay = 0;
	}
	
	//SI_SetVerticalBlanking(m_iCamID, m_VerticalBlanking);
	TRACE("m_Width before begin capture: %d\n", m_Width);
	if(SI_BeginCapture(&m_Config, &m_CaptureContext ) != SR_OK)
	{		
		AfxMessageBox("camera init failed\n");
		return FALSE;
	}
	
	
	//else
	//	AfxMessageBox("stop");

	
	
	
	m_bInitialized = TRUE;
	;
		
	

	if (!m_bSpecialSettings && ((m_CamIdent == SI1280) || (m_CamIdent == SI6600)))
	{
		SI_SetColumnOffset(m_iCamID, m_ColumnOffset);
		SI_SetBlackOffset(m_iCamID, m_BlackLevel);
	}

	TRACE("width out of init: %d\n", m_Width);
	
	return TRUE;	
}

void CSI004Doc::ShowImage(const SIPackedDIB* pPackedDIB)
{
	POSITION pos = GetFirstViewPosition();
	CSI004View * pView = static_cast<CSI004View*>(GetNextView( pos ));
	pView->ShowImage(pPackedDIB);	
}

void CSI004Doc::OnActionLiveStart()
{
	unsigned char buffer[3];
	if (m_LiveType !=0)
		return;

	m_LiveType = 3;
	if(!InitCapture()) return;
	
	if(m_Status != Run)
	{    		
		m_bStopLiveFlag = 0;
		if (m_bSpecialSettings)
			SetSpecialSettings();
		
		if (m_CamIdent == SI1280 || m_CamIdent == SI6600)
			SI_InitWindowMode(m_iCamID, m_StartRow/m_Subsampling, m_HeightStart/m_Subsampling - 1 + m_StartRow/m_Subsampling, m_StartColumn/m_Subsampling, 
				m_WidthStart/m_Subsampling - 1 + m_StartColumn/m_Subsampling, 0, m_ExposureTime);	

		else
		{
			SI_InitWindowMode(m_iCamID, m_StartRow, m_HeightStart - 1 + m_StartRow, m_StartColumn, m_WidthStart - 1 + m_StartColumn, 0, m_ExposureTime);	
		}
		TRACE("m_WidthStart: %d m_HeightStart: %d\n", m_WidthStart, m_HeightStart);
		m_image.resize(m_WidthStart, m_HeightStart);
				
		SI_SetClockB(m_iCamID, m_ClockIndex);
		
				
		m_hEvent1 = ::CreateEvent(NULL, FALSE, FALSE, NULL);
		m_hEvent2 = ::CreateEvent(NULL, FALSE, FALSE, NULL);
		m_hEvent3 = ::CreateEvent(NULL, FALSE, FALSE, NULL);
		
		m_hLiveThread = ::CreateThread(NULL,0,LiveThreadFunc,this,CREATE_SUSPENDED,NULL);
	    m_hLiveDisplayThread = ::CreateThread(NULL,0,LiveDisplayThreadFunc,this,CREATE_SUSPENDED,NULL);
		m_Status = Run;
		
		::ResumeThread(m_hLiveThread);		
		::ResumeThread(m_hLiveDisplayThread);
				
  	}		
			
}



DWORD WINAPI CSI004Doc::LiveSeqThreadFunc(LPVOID pParam)
{
	CSI004Doc * pDoc = static_cast<CSI004Doc*>(pParam);
	int iBytesRead; 
	int sts, iDepth;

	// allocate double buffer	
	if (pDoc->m_Bpp == 8)
		iDepth = 1;
	else 
		iDepth = 2;

	//iDepth = 1;		// force to 8 bits temporarily
	//pDoc->m_Bpp = 8;
	
	sts = SI_SnapBulkLiveStart(pDoc->m_iCamID, pDoc->m_Width, pDoc->m_Height, pDoc->m_Bpp, pDoc->pBuffer, 
						 pDoc->m_SnapCount, pDoc->m_hEvent1, NULL, pDoc->m_hEvent3);
		
	if (sts != SI_STATUS_SUCCESS)
		AfxMessageBox("continuous capture error\n");
			
	return 0;
}

DWORD WINAPI CSI004Doc::LiveSeqDisplayThreadFunc(LPVOID pParam)
{
	DWORD dwStart, dwEnd, TimeArray[20], CountArray[20], ret;
	double TotalSecs;
	HANDLE hEventArray[2];

	CSI004Doc * pDoc = static_cast<CSI004Doc*>(pParam);

	pDoc->m_BadCount = 0;

	hEventArray[0] = pDoc->m_hEvent1;
	hEventArray[1] = pDoc->m_hEvent3;
	
	pDoc->m_dwFrame = 0;
	pDoc->m_Fps = 0.0;

	for (int i= 0;  i < 20; i++)
	{
		TimeArray[i] = 0;
		CountArray[i] = 0;
	}

	// Prepare the Bitmap data structure for display.
	if (!pDoc->m_bBMAlreadyAllocated)
	{
		pDoc->m_pBmi = (BITMAPINFOHEADER*)(new BYTE[sizeof(BITMAPINFOHEADER) + 256*sizeof(RGBQUAD)]);
		ZeroMemory(pDoc->m_pBmi,sizeof(BITMAPINFOHEADER));
		pDoc->m_pBmi->biSize				= sizeof(BITMAPINFOHEADER);
		pDoc->m_pBmi->biWidth				= pDoc->m_Width;
		pDoc->m_pBmi->biHeight				= pDoc->m_Height;
		pDoc->m_pBmi->biPlanes				= 1;
		pDoc->m_pBmi->biBitCount			= 8;			
		pDoc->m_pBmi->biCompression	= BI_RGB;
		pDoc->m_bBMAlreadyAllocated = 1;
	}

	RGBQUAD * pQuad = (RGBQUAD*)(reinterpret_cast<BYTE*>(pDoc->m_pBmi) + sizeof(BITMAPINFOHEADER));	

	for(int i=0; i<256; i++)
	{
		pQuad->rgbBlue = pQuad->rgbGreen = pQuad->rgbRed = i;
		pQuad->rgbReserved = 0;
		pQuad++;
	}

	// display images from double buffer
	int iBuffer;
	POSITION pos = pDoc->GetFirstViewPosition();
	if (pos != NULL)
	{			
		CView* pView = pDoc->GetNextView(pos);
		iBuffer = 0;

		//pView->GetImageDC();
		
		while (iBuffer < pDoc->m_SnapCount)
		{	
			// wait for appropriate capture to be completed
			ret = WaitForMultipleObjects(2, hEventArray, FALSE, 20000);
			
			iBuffer++;
			pDoc->m_dwFrame++;
								
			// update timer variables	
			dwEnd = GetTickCount();
			TotalSecs = ((double)(dwEnd - TimeArray[0]))/1000.0;
			if (pDoc->m_dwFrame > 20)
				pDoc->m_Fps = (1.0 *(pDoc->m_dwFrame - CountArray[0]))/TotalSecs;

			for (int i = 0; i < 19; i++)
			{
				CountArray[i] = CountArray[i + 1];
				TimeArray[i] = TimeArray[i + 1];
			}
			CountArray[19] = pDoc->m_dwFrame;
			TimeArray[19] = dwEnd;
			
						
			ASSERT(pView->IsKindOf(RUNTIME_CLASS(CSI004View)));

			if ((ret - WAIT_OBJECT_0) != 1)
				((CSI004View*)pView)->Display(reinterpret_cast<BITMAPINFO*>(pDoc->m_pBmi),pDoc->pBuffer + 
					(iBuffer - 1) * (pDoc->m_Width * pDoc->m_Height));
			else 
			{
				pDoc->m_BadCount++;				
			}	
			
	}
		
	Sleep(200);
	((CSI004View*)pView)->Display(reinterpret_cast<BITMAPINFO*>(pDoc->m_pBmi),pDoc->pBuffer + (iBuffer-1) * (pDoc->m_Width * pDoc->m_Height));
	//((CSI004View*)pView)->Display(reinterpret_cast<BITMAPINFO*>(pDoc->m_pBmi),pDBuffer3 + iBuffer * (pDoc->m_Width * pDoc->m_Height));

	}

	pDoc->m_LiveType = 0;
	
	
	pDoc->m_Status = Stop;

	delete [] pDoc->m_pBmi;
			
	return 0;
}

void CSI004Doc::OnActionSequencedLiveStart()
{	
	int iDepth;
	if(!InitCapture())
	{
		AfxMessageBox("Image init failed");
		return;
	}

	if (m_bSpecialSettings)
		SetSpecialSettings();

	if (m_LiveType != 0) 
		return;

	m_LiveType = 4;
	
	if (DialogParam.DoModal() == IDOK)
	{	
		m_SnapCount = DialogParam.m_SnapCount;
	}
	else
		return;

	m_Status = Run;

	if (m_Bpp == 8)
		iDepth = 1;
	else 
		iDepth = 2;

	iDepth = 1;  //force to 8 bits temporarily
	m_Bpp = 8;

	int iSize = iDepth * m_Width * m_Height * m_SnapCount; 
	
	// allocate sequence of buffers	
	if (m_bCaptureSequenceBuffer)
		delete [] pBuffer;

	pBuffer = new BYTE[iSize];

	if (pBuffer == NULL)
	{
		AfxMessageBox("NULL on new");
		return;
	}

	m_bCaptureSequenceBuffer = 1;

	if (m_CamIdent == SI1280 || m_CamIdent == SI6600)
		SI_InitWindowMode(m_iCamID, m_StartRow/m_Subsampling, m_HeightStart/m_Subsampling - 1 + m_StartRow/m_Subsampling, m_StartColumn/m_Subsampling, 
			m_WidthStart/m_Subsampling - 1 + m_StartColumn/m_Subsampling, 0, m_ExposureTime);	

	else
		SI_InitWindowMode(m_iCamID, m_StartRow, m_HeightStart - 1 + m_StartRow, m_StartColumn, m_WidthStart - 1 + m_StartColumn, 0, m_ExposureTime);	


	SI_SetClockB(m_iCamID, m_ClockIndex);
			
	m_hEvent1 = ::CreateEvent(NULL, FALSE, FALSE, NULL);	
	m_hEvent3 = ::CreateEvent(NULL, FALSE, FALSE, NULL);
		
	m_hLiveSeqThread = ::CreateThread(NULL,0,LiveSeqThreadFunc,this,CREATE_SUSPENDED,NULL);
	m_hLiveSeqDisplayThread = ::CreateThread(NULL,0,LiveSeqDisplayThreadFunc,this,CREATE_SUSPENDED,NULL);
	m_Status = Run;
		
	::ResumeThread(m_hLiveSeqThread);		
	::ResumeThread(m_hLiveSeqDisplayThread);
		
	return;
}


DWORD WINAPI CSI004Doc::SnapLoopThreadFunc(LPVOID pParam)
{
	CSI004Doc * pDoc = static_cast<CSI004Doc*>(pParam);
	int iBytesRead; 
	int sts, iDepth;
	DWORD dwStart, dwEnd, TimeArray[20], CountArray[20];
	double TotalSecs;
	SIMonoImage mono;
	SIPoint dpclist[10000];
	int iFirst;
	unsigned short* pDBufferS;
	unsigned char* pBack;
	
	pDoc->m_dwFrame = 0;
	pDoc->m_Fps = 0.0;
	pDoc->m_BadCount = 0;

	for (int i= 0;  i < 20; i++)
	{
		TimeArray[i] = 0;
		CountArray[i] = 0;
	}

	if (pDoc->m_Bpp == 8)
		iDepth = 1;
	else
		iDepth = 2;

	// Prepare the Bitmap data structure for display.	
	BITMAPINFOHEADER * pBmi = (BITMAPINFOHEADER*)(new BYTE[sizeof(BITMAPINFOHEADER) + 256*sizeof(RGBQUAD)]);
	ZeroMemory(pBmi,sizeof(BITMAPINFOHEADER));
	pBmi->biSize					= sizeof(BITMAPINFOHEADER);
	pBmi->biWidth					= pDoc->m_Width;
	pBmi->biHeight				=	pDoc->m_Height;
	pBmi->biPlanes				= 1;
	pBmi->biBitCount			= 8;			
	pBmi->biCompression	= BI_RGB;	
	

	RGBQUAD * pQuad = (RGBQUAD*)(reinterpret_cast<BYTE*>(pBmi) + sizeof(BITMAPINFOHEADER));	

	for(int i=0; i<256; i++)
	{
		pQuad->rgbBlue = pQuad->rgbGreen = pQuad->rgbRed = i;
		pQuad->rgbReserved = 0;
		pQuad++;
	}

	mono.iWidth = pDoc->m_Width;
	mono.iHeight = pDoc->m_Height;
	mono.iPitch = mono.iWidth;
	mono.iBpp = 8;
		
	pDoc->m_dwFrame = 0;

	int iSize = iDepth * (pDoc->m_Width * pDoc->m_Height);  
	pDoc->pDBuffer2 = new BYTE[iSize];
	PBYTE pDBuffer3 = (PBYTE) new BYTE[iSize/2];
		
	POSITION pos = pDoc->GetFirstViewPosition();
				
	CView* pView = pDoc->GetNextView(pos);
	ASSERT(pView->IsKindOf(RUNTIME_CLASS(CSI004View)));
	iFirst = 1;

	pDBufferS = (unsigned short*) pDoc->pDBuffer2;
	pBack = pDoc->pDBuffer2;
	while(pDoc->m_bSnapLoopFlag)
	{
		sts = SI_SnapBulkImage(pDoc->m_iCamID, pDoc->m_Width, pDoc->m_Height, pDoc->m_Bpp, pDoc->pDBuffer2, 
						 &iBytesRead);

		if (pDoc->m_AutoExposure && iDepth == 1)
			SI_SetAutoExposure(pDoc->m_iCamID, pDoc->m_Width, pDoc->m_Height, pDoc->pDBuffer2);


	if (pDoc->m_Bpp == 12)
	{
		for (i = 0; i < iSize/2; i++)
		{			
		pDBuffer3[i] = pDBufferS[i]/16;		
		}			
		pDoc->pDBuffer2 = pDBuffer3;		
	}

		TRACE("passed conversion to 8 bits\n");
		if (pDoc->m_DPCOn) // && pDoc->m_Bpp == 8)
			{
				if (iFirst)
					{
					iFirst = 0;
					mono.Data.pData8u = pDoc->pDBuffer2;
					SI_DeviantPixelDetection(&mono,SIDPC_CSSAD,&(pDoc->m_DPCNum), dpclist, pDoc->m_DPCNum);					
					}
				if (pDoc->m_dwFrame > 1)
				{					
					mono.Data.pData8u = pDoc->pDBuffer2;
					SI_DeviantPixelCorrection(&mono, pDoc->m_DPCNum,dpclist);					
				}
			}

		// update timer variables	
		pDoc->m_dwFrame++;
		dwEnd = GetTickCount();
		TotalSecs = ((double)(dwEnd - TimeArray[0]))/1000.0;
		if (pDoc->m_dwFrame > 20)
			pDoc->m_Fps = (1.0 *(pDoc->m_dwFrame - CountArray[0]))/TotalSecs;

		for (int i = 0; i < 19; i++)
		{
			CountArray[i] = CountArray[i + 1];
			TimeArray[i] = TimeArray[i + 1];
		}
		CountArray[19] = pDoc->m_dwFrame;
		TimeArray[19] = dwEnd;

	
		if (sts != SI_STATUS_SUCCESS || (iBytesRead != iDepth * (pDoc->m_Width * pDoc->m_Height)))
		{
			pDoc->m_BadCount++;
			if (!pDoc->m_bDisplay )
				{					
					
					if (pDoc->m_InvalidShown)
					{
						((CSI004View*)pView)->Display(reinterpret_cast<BITMAPINFO*>(pBmi),pDoc->pDBuffer2);		
					}
				}
		}
		else
		{
			if (pDoc->m_bDisplay )
				((CSI004View*)pView)->Display(reinterpret_cast<BITMAPINFO*>(pBmi),pDoc->pDBuffer2);	
				TRACE("passed display\n");
		}
		pDoc->pDBuffer2 = pBack;
	}

	//Sleep(200);

	pDoc->pDBuffer2 = pDBuffer3;
	if (pDoc->m_bDisplay )
		((CSI004View*)pView)->Display(reinterpret_cast<BITMAPINFO*>(pBmi),pDoc->pDBuffer2);
	
	
	delete [] pBmi;
	delete [] pDoc->pDBuffer2;
	

	pDoc->m_bDAlreadyAllocated = 0;
			
	return 0;
}




void CSI004Doc::OnActionStartSnapLoop()
{
	if (m_LiveType != 0)
		return;
	if(!InitCapture())
	{
		AfxMessageBox("Image init failed");
		return;
	}

	if (m_bSpecialSettings)
		SetSpecialSettings();

	if (m_Status == Run)
		return;
	

	m_LiveType = 1;

	if (m_CamIdent == SI1280 || m_CamIdent == SI6600)
		SI_InitWindowMode(m_iCamID, m_StartRow/m_Subsampling, m_HeightStart/m_Subsampling - 1 + m_StartRow/m_Subsampling, m_StartColumn/m_Subsampling, 
			m_WidthStart/m_Subsampling - 1 + m_StartColumn/m_Subsampling, 0, m_ExposureTime);	

	else
		SI_InitWindowMode(m_iCamID, m_StartRow, m_HeightStart - 1 + m_StartRow, m_StartColumn, m_WidthStart - 1 + m_StartColumn, 0, m_ExposureTime);	


	SI_SetClockB(m_iCamID, m_ClockIndex);
			
	m_bSnapLoopFlag = 1;
	
	m_hSnapLoopThread = ::CreateThread(NULL,0,SnapLoopThreadFunc,this,CREATE_SUSPENDED,NULL);
	    
	m_Status = Run;
		
	::ResumeThread(m_hSnapLoopThread);		

	return;
	
}


void CSI004Doc::OnActionDisplayLiveSequence()
{
	// TODO: Add your command handler code here
	// Prepare the Bitmap data structure for display.

	if (m_LiveType != 0)
		return;

	if (!m_bCaptureSequenceBuffer)
	{
		AfxMessageBox("capture sequence not available");
		return;
	}

	m_LiveType = 6;
	m_Status = Run;

	BITMAPINFOHEADER * pBmi = (BITMAPINFOHEADER*)(new BYTE[sizeof(BITMAPINFOHEADER) + 256*sizeof(RGBQUAD)]);
	ZeroMemory(pBmi,sizeof(BITMAPINFOHEADER));
	pBmi->biSize					= sizeof(BITMAPINFOHEADER);
	pBmi->biWidth					= m_Width;
	pBmi->biHeight				=	m_Height;
	pBmi->biPlanes				= 1;
	pBmi->biBitCount			= 8;			
	pBmi->biCompression	= BI_RGB;	

	RGBQUAD * pQuad = (RGBQUAD*)(reinterpret_cast<BYTE*>(pBmi) + sizeof(BITMAPINFOHEADER));	

	for(int i=0; i<256; i++)
	{
		pQuad->rgbBlue = pQuad->rgbGreen = pQuad->rgbRed = i;
		pQuad->rgbReserved = 0;
		pQuad++;
	}
			
	m_dwFrame = 0;		
    m_Fps = 0;
	m_BadCount = 0;
	m_bDisplaySequence = TRUE;
		
	POSITION pos = GetFirstViewPosition();
    if(pos != NULL)
		{			
			CView* pView = GetNextView(pos);

			for (int j = 0; j < m_SnapCount; j++)
			{								
				m_dwFrame = j + 1;
				ASSERT(pView->IsKindOf(RUNTIME_CLASS(CSI004View)));
				((CSI004View*)pView)->Display(reinterpret_cast<BITMAPINFO*>(pBmi),pBuffer+ j * (m_Width * m_Height));				
				//AfxMessageBox("display loop");
				Sleep(100);
				if (!m_bDisplaySequence)
				{
					AfxMessageBox("breaking");
					m_bDisplaySequence = FALSE;
					break;
				}
			}
  		}

	//m_LiveType = 0;
	
	
	//m_Status = Stop;
		
	delete [] pBmi;

	Sleep(400);	
}



void CSI004Doc::OnSI1300Initialize()
{
	char pcDriverName[8]   = "Ezusb-0";
	int ret;

	m_Width = 640;
	m_Height = 480;
	m_ClockIndex = 10;

	ret = SI_OpenCamera(m_iCamID, pcDriverName);
	if (ret != SI_STATUS_SUCCESS)
	{
		AfxMessageBox("open failed");
		return;
	}

	if (m_bSpecialSettings)
		SetSpecialSettings();

	if (m_CamIdent == SI1280 || m_CamIdent == SI6600)
		SI_InitWindowMode(m_iCamID, m_StartRow/m_Subsampling, m_HeightStart/m_Subsampling - 1 + m_StartRow/m_Subsampling, m_StartColumn/m_Subsampling, 
			m_WidthStart/m_Subsampling - 1 + m_StartColumn/m_Subsampling, 0, m_ExposureTime);	

	else
		ret = SI_InitWindowMode(m_iCamID, m_StartRow, m_HeightStart - 1 + m_StartRow, m_StartColumn, m_WidthStart - 1 + m_StartColumn, 0, m_ExposureTime);	

	if (ret != SI_STATUS_SUCCESS)
	{
		AfxMessageBox("init window failed");
		return;
	}

	ret = SI_SetClockB(m_iCamID, m_ClockIndex);

	
	if (ret != SI_STATUS_SUCCESS)
	{
		AfxMessageBox("set clock failed");
		return;
	}

}



void CSI004Doc::OnSi1300SnapA()
{
	// TODO: Add your command handler code here
	int ret, iBytesRead;
	char mbuf[64];

	int iSize = m_Width * m_Height;
	//pDBuffer2 = new BYTE[iSize];

	BITMAPINFOHEADER * pBmi = (BITMAPINFOHEADER*)(new BYTE[sizeof(BITMAPINFOHEADER) + 256*sizeof(RGBQUAD)]);
	ZeroMemory(pBmi,sizeof(BITMAPINFOHEADER));
	pBmi->biSize					= sizeof(BITMAPINFOHEADER);
	pBmi->biWidth					= m_Width;
	pBmi->biHeight				=	m_Height;
	pBmi->biPlanes				= 1;
	pBmi->biBitCount			= 8;			
	pBmi->biCompression	= BI_RGB;	

	RGBQUAD * pQuad = (RGBQUAD*)(reinterpret_cast<BYTE*>(pBmi) + sizeof(BITMAPINFOHEADER));	

	for(int i=0; i<256; i++)
	{
		pQuad->rgbBlue = pQuad->rgbGreen = pQuad->rgbRed = i;
		pQuad->rgbReserved = 0;
		pQuad++;
	}

	m_dwFrame = 0;		
    m_Fps = 0;
	ret = SI_SnapBulkImage(m_iCamID, m_Width, m_Height, 8, pDBuffer2, &iBytesRead);
	if (ret != SI_STATUS_SUCCESS)
	{
		AfxMessageBox("snap failed");
		return;
	}
		
	//sprintf(mbuf,"Bytes read: %d", iBytesRead);
	//AfxMessageBox(mbuf);

	POSITION pos = GetFirstViewPosition();
    if(pos != NULL)
		{			
			CView* pView = GetNextView(pos);									
			ASSERT(pView->IsKindOf(RUNTIME_CLASS(CSI004View)));
			((CSI004View*)pView)->Display(reinterpret_cast<BITMAPINFO*>(pBmi),pDBuffer2);							
  		}
		
	delete [] pBmi;
	delete [] pDBuffer2;
}

DWORD WINAPI CSI004Doc::DisarmThreadFunc(LPVOID pParam)
{	
	CSI004Doc * pDoc = static_cast<CSI004Doc*>(pParam);
	SI_DisarmTrigger(pDoc->m_iCamID);		
	delete [] pDoc->pDBuffer2;
	return 0;
}



void CSI004Doc::OnActionSingleSnapMono()
{
	
	int ret, iBytesRead, i;
	char mbuf[64];
	SIMonoImage ImgData;
	int n;
	
	SIPoint dpclist[10000];
	int dpc_num = m_DPCNum;
	SIMonoImage mono;
	PBYTE pDBuffer2;
	int iScale;

	if (m_LiveType != 0)
		return;
	
	if(!InitCapture()) return;
	
	
	if (m_bSpecialSettings)
		SetSpecialSettings();	
	if (m_Bpp == 8)
	{
		iScale = 1;
		
	}
	else 
		iScale = 2;

	int iSize = iScale * m_Width * m_Height;

	BITMAPINFOHEADER * pBmi;
	
	PBYTE pDBuffer3 = (PBYTE) new BYTE[iSize/2];
	PBYTE pDBuffer4; 
	
	pBmi = (BITMAPINFOHEADER*)(new BYTE[sizeof(BITMAPINFOHEADER) + 256*sizeof(RGBQUAD) + iSize]);
		
	ZeroMemory(pBmi,sizeof(BITMAPINFOHEADER));
	pBmi->biSize					= sizeof(BITMAPINFOHEADER);
	pBmi->biWidth					= m_Width/m_DisplaySubsamp;
	pBmi->biHeight				=	m_Height/m_DisplaySubsamp;
	pBmi->biPlanes				= 1;
	pBmi->biBitCount			= 8;			
	pBmi->biCompression	= BI_RGB;	


	RGBQUAD * pQuad = (RGBQUAD*)(reinterpret_cast<BYTE*>(pBmi) + sizeof(BITMAPINFOHEADER));	
	pDBuffer2 = (PBYTE)(reinterpret_cast<BYTE*>(pBmi) + sizeof(BITMAPINFOHEADER) + 256*sizeof(RGBQUAD));	
	//pDBuffer4 = (PBYTE)(reinterpret_cast<BYTE*>(pBmi2) + sizeof(BITMAPINFOHEADER) + 256*sizeof(RGBQUAD));
	pDBuffer4 = pDBuffer2;

	for(i=0; i<256; i++)
	{
		pQuad->rgbBlue = pQuad->rgbGreen = pQuad->rgbRed = i;
		pQuad->rgbReserved = 0;
		pQuad++;
	}

	m_dwFrame = 0;		
    m_Fps = 0;
	m_BadCount = 0;
	
	if (m_CamIdent == SI1280 || m_CamIdent == SI6600)
	{
		SI_InitWindowMode(m_iCamID, m_StartRow/m_Subsampling, m_HeightStart/m_Subsampling - 1 + m_StartRow/m_Subsampling, m_StartColumn/m_Subsampling, 
			m_WidthStart/m_Subsampling - 1 + m_StartColumn/m_Subsampling, 0, m_ExposureTime);	
	}
	else if (m_CamIdent == SI1300 || m_CamIdent == SI3300 ||m_CamIdent == SI2100  || m_CamIdent == SI5100)
	{
		SI_InitWindowMode(m_iCamID, m_StartRow, m_HeightStart - 1 + m_StartRow, m_StartColumn, m_WidthStart - 1 + m_StartColumn, 0, m_ExposureTime);	
	}
	else
		SI_InitWindowMode(m_iCamID, m_StartRow, m_HeightStart - 1 + m_StartRow, m_StartColumn, m_WidthStart - 1 + m_StartColumn, 2200, m_ExposureTime);	

	TRACE("pixel depth: %d\n", m_Bpp);
	SI_SetPixelDepth(m_iCamID, m_Bpp);
	Sleep(1000);
	ret = SI_SetClockB(m_iCamID, m_ClockIndex);
	//Sleep(1000);
	
	
	mono.iWidth = m_Width;
	mono.iHeight = m_Height;
	mono.iPitch = mono.iWidth;
	mono.iBpp = m_Bpp;
	mono.Data.pData8u = pDBuffer2;
	
	//m_hDisarmThread = ::CreateThread(NULL,0,DisarmThreadFunc,this,CREATE_SUSPENDED,NULL);		
	//::ResumeThread(m_hDisarmThread);

	//TRACE("start arming\n");
	//AfxMessageBox("arming trigger and waiting");				
	//SI_ArmTriggerWait(0);
	//AfxMessageBox("trigger disarmed");			
	//TRACE(" trigger disabled\n");
	

	TRACE("m_DisplaySubsamp: %d\n", m_DisplaySubsamp);	
	ret = SI_SnapBulkImage(m_iCamID, m_Width, m_Height, m_Bpp, pDBuffer2, &iBytesRead);
	if (ret == SI_STATUS_FAILURE)
	{
		//AfxMessageBox("snap failed");
		return;
	}

	
	

	TRACE("bytes read: %d\n", iBytesRead);


	if (ret == SI_STATUS_INCORRECT_SIZE_RETURNED)
	{
		AfxMessageBox("incorrect size of read");
		TRACE("bytes read: %d\n", iBytesRead);
	}

	if (m_DPCOn && m_Bpp == 8)
	{
		SI_DeviantPixelDetection(&mono,SIDPC_CSSAD,&dpc_num, dpclist,m_DPCNum);
		SI_DeviantPixelCorrection(&mono,dpc_num,dpclist);
	}

	//SI_BayerToRGBP3(SIMonoImage * pSrc, SIColorImage * pDst, SIBayerPhase bp, SIBayerInterpAlgorithm algo);
	
	// test of 12 bit mono mode
	unsigned short* pDBufferS;
	unsigned short* pbayer;
	pDBufferS = (unsigned short*) pDBuffer2;
	unsigned char byte;
	if (m_Bpp == 12)
	{

		for (i = 0; i < iSize/2; i++)
		{			
			pDBuffer3[i] = pDBufferS[i]/16;		
		}

		TRACE("12 bit conversion\n");
		pbayer = (unsigned short*)pDBuffer2;
		n = m_Width * m_Height;
						
		for (int ii = 0; ii < n; ii++)
			{
				//if (ii > n/2 && ii < (n/2 + 20))
				//	TRACE("ii: %d *pbayer: %x\n", ii, *pbayer);

				if (*pbayer > 4095)
					{
						//TRACE("i: %d *pbayer: %x\n",i, *pbayer);
						*pbayer = 4095;
					}
				else
					*pbayer = m_lut[*pbayer] * 16;

				byte = pDBuffer2[2 * ii + 1];
				pDBuffer2[2 * ii + 1] = pDBuffer2[2 * ii];
				pDBuffer2[2 * ii] = byte;
				//if (ii > n/2 && ii < n/2 + 30)
				//	TRACE("ii: %d *pbayer: %d\n",ii, *pbayer);

				pbayer++;
				
			}
				
	}

	
	int iC = 0;
	
	if (m_DisplaySubsamp > 1)
	{
		for (int j = 0; j < m_Height; j=j+ m_DisplaySubsamp)
		{
			for (int i = 0; i < m_Width; i = i + m_DisplaySubsamp)
			{
				pDBuffer4[iC] = pDBuffer2[j*m_Width + i];
				iC++;;
			}
		}
	}



		
	POSITION pos = GetFirstViewPosition();
    if(pos != NULL)
		{			
			CView* pView = GetNextView(pos);									
			ASSERT(pView->IsKindOf(RUNTIME_CLASS(CSI004View)));
			if (m_Bpp == 8)	
			{
				if (m_DisplaySubsamp == 1)
					((CSI004View*)pView)->Display(reinterpret_cast<BITMAPINFO*>(pBmi),pDBuffer2);				
				else
					((CSI004View*)pView)->Display(reinterpret_cast<BITMAPINFO*>(pBmi),pDBuffer4);	
			}
			else
				((CSI004View*)pView)->Display(reinterpret_cast<BITMAPINFO*>(pBmi),pDBuffer3);
			
  		}

	if (m_SaveFlag)
	{
		pBmi->biHeight	=	-m_Height; // invert for saved bmp
		if (m_Bpp == 8)
			ret = SI_SaveDIBFile(reinterpret_cast<BITMAPINFO*>(pBmi), m_Filename);
		if (ret != SR_OK)
			AfxMessageBox("file write error\n");
	}
	//ret = SI_SaveBinFileB(pDBuffer2, iSize, "test.bin");
	//ret = SI_SaveTiffFile(pDBuffer2, m_Width, m_Height, m_Bpp, 0, "test.tif");	
	if (ret == SI_STATUS_FAILURE)
		AfxMessageBox("tiff write failed");

	//ret = SI_SaveDngFile(pDBuffer2, m_Width, m_Height, m_Bpp, 0, "testdng.tif");
	//if (ret == SI_STATUS_FAILURE)
	//	AfxMessageBox("dng write failed");

		
	delete [] pBmi;
	
	//delete []pDBuffer4;
	//delete [] pDBuffer2;	
}


DWORD WINAPI CSI004Doc::DBSnapLoopThreadFunc(LPVOID pParam)
{
	CSI004Doc * pDoc = static_cast<CSI004Doc*>(pParam);
	int iBytesRead; 
	int sts;
		
	pDoc->m_Bpp = 8;

	pDoc->m_dwFrame = 0;
	pDoc->m_Fps = 0.0;
	pDoc->m_BadCount = 0;
	
	int iSize = 2 * (pDoc->m_Width * pDoc->m_Height);  
	pDoc->pDBuffer2 = new BYTE[iSize];
	
	POSITION pos = pDoc->GetFirstViewPosition();
				
	CView* pView = pDoc->GetNextView(pos);
	ASSERT(pView->IsKindOf(RUNTIME_CLASS(CSI004View)));

	SI_SetImageBuffers(pDoc->m_iCamID, pDoc->pDBuffer2, pDoc->pDBuffer2 + iSize/2);

	pDoc->m_Buffer = 0;
	pDoc->m_hEventDB = ::CreateEvent(NULL, FALSE, FALSE, NULL);
	while(pDoc->m_bDBSnapFlag)
	{

		sts = SI_SnapBulkDoubleBuffer(pDoc->m_iCamID, pDoc->m_Width, pDoc->m_Height, pDoc->m_Bpp, pDoc->m_Buffer, pDoc->m_hEventDB, &iBytesRead);
				
		if (sts != SI_STATUS_SUCCESS || iBytesRead != ((pDoc->m_Width * pDoc->m_Height) + 1))
		{
			pDoc->m_BadCount++;			
		}

		if (!pDoc->m_Buffer)
			pDoc->m_Buffer = 1;
		else 
			pDoc->m_Buffer = 0;
	}

	Sleep(200);
	
	CloseHandle(pDoc->m_hEventDB);
			
	return 0;
}

DWORD WINAPI CSI004Doc::DBDisplayLoopThreadFunc(LPVOID pParam)
{
	DWORD dwStart, dwEnd, TimeArray[20], CountArray[20], ret;
	double TotalSecs;

	CSI004Doc * pDoc = static_cast<CSI004Doc*>(pParam);
	
	int iSize = 2 * (pDoc->m_Width * pDoc->m_Height);  
		
	int iCount = 0;

	for (int i= 0;  i < 20; i++)
	{
		TimeArray[i] = 0;
		CountArray[i] = 0;
	}
	
		
	// Prepare the Bitmap data structure for display.
	if (!pDoc->m_bBMAlreadyAllocated)
	{
		pDoc->m_pBmi = (BITMAPINFOHEADER*)(new BYTE[sizeof(BITMAPINFOHEADER) + 256*sizeof(RGBQUAD)]);
		ZeroMemory(pDoc->m_pBmi,sizeof(BITMAPINFOHEADER));
		pDoc->m_pBmi->biSize				= sizeof(BITMAPINFOHEADER);
		pDoc->m_pBmi->biWidth				= pDoc->m_Width;
		pDoc->m_pBmi->biHeight				= pDoc->m_Height;
		pDoc->m_pBmi->biPlanes				= 1;
		pDoc->m_pBmi->biBitCount			= 8;			
		pDoc->m_pBmi->biCompression	= BI_RGB;
		pDoc->m_bBMAlreadyAllocated = 1;
	}

	RGBQUAD * pQuad = (RGBQUAD*)(reinterpret_cast<BYTE*>(pDoc->m_pBmi) + sizeof(BITMAPINFOHEADER));	

	for(int i=0; i<256; i++)
	{
		pQuad->rgbBlue = pQuad->rgbGreen = pQuad->rgbRed = i;
		pQuad->rgbReserved = 0;
		pQuad++;
	}

	// display images from double buffer
	
	POSITION pos = pDoc->GetFirstViewPosition();
	if (pos != NULL)
	{			
		CView* pView = pDoc->GetNextView(pos);
						
		while (pDoc->m_bDBSnapFlag)
		{	
			// wait for appropriate capture to be completed
			//if (!iBuffer)
			
			ret = WaitForSingleObject(pDoc->m_hEventDB, 20000);
			pDoc->m_dwFrame++;
			iCount++;
			// update timer variables	
			dwEnd = GetTickCount();
			TotalSecs = ((double)(dwEnd - TimeArray[0]))/1000.0;
			if (pDoc->m_dwFrame > 20)
				pDoc->m_Fps = (1.0 *(pDoc->m_dwFrame - CountArray[0]))/TotalSecs;

			for (int i = 0; i < 19; i++)
			{
				CountArray[i] = CountArray[i + 1];
				TimeArray[i] = TimeArray[i + 1];
			}
			CountArray[19] = pDoc->m_dwFrame;
			TimeArray[19] = dwEnd;
			
						
			ASSERT(pView->IsKindOf(RUNTIME_CLASS(CSI004View)));
			((CSI004View*)pView)->Display(reinterpret_cast<BITMAPINFO*>(pDoc->m_pBmi),pDoc->pDBuffer2 + (1 - pDoc->m_Buffer) * (pDoc->m_Width * pDoc->m_Height));
			
	}
		
	if (pDoc->m_Buffer)
		pDoc->m_Buffer = 1;
	else
		pDoc->m_Buffer = 0;
	

	Sleep(200);
	((CSI004View*)pView)->Display(reinterpret_cast<BITMAPINFO*>(pDoc->m_pBmi),pDoc->pDBuffer2 + (1 - pDoc->m_Buffer) * (pDoc->m_Width * pDoc->m_Height));
	
	}
		
	delete [] pDoc->m_pBmi;
	pDoc->m_bBMAlreadyAllocated = 0;
	delete [] pDoc->pDBuffer2;
	
	CloseHandle(pDoc->m_hDBSnapLoopThread);
	CloseHandle(pDoc->m_hDBDisplayLoopThread);

	return 0;
}

	
void CSI004Doc::OnActionStartDBSnapLoop()
{

	if (m_LiveType != 0)
		return;
	if(!InitCapture())
	{
		AfxMessageBox("Image init failed");
		return;
	}

	if (m_bSpecialSettings)
		SetSpecialSettings();

	if (m_Status == Run)
		return;
	

	m_LiveType = 2;
	m_BadCount = 0;

	if (m_CamIdent == SI1280  || m_CamIdent == SI6600)
		SI_InitWindowMode(m_iCamID, m_StartRow/m_Subsampling, m_HeightStart/m_Subsampling - 1 + m_StartRow/m_Subsampling, m_StartColumn/m_Subsampling, 
			m_WidthStart/m_Subsampling - 1 + m_StartColumn/m_Subsampling, 0, m_ExposureTime);	
	else
		SI_InitWindowMode(m_iCamID, m_StartRow, m_HeightStart - 1 + m_StartRow, m_StartColumn, m_WidthStart - 1 + m_StartColumn, 0, m_ExposureTime);	

	
	SI_SetClockB(m_iCamID, m_ClockIndex);

	m_bDBSnapFlag = 1;
	m_hEventDB = ::CreateEvent(NULL, FALSE, FALSE, NULL);
	
	m_hDBSnapLoopThread = ::CreateThread(NULL,0,DBSnapLoopThreadFunc,this,CREATE_SUSPENDED,NULL);
	m_hDBDisplayLoopThread = ::CreateThread(NULL,0,DBDisplayLoopThreadFunc,this,CREATE_SUSPENDED,NULL);
	    
	m_Status = Run;
		
	::ResumeThread(m_hDBSnapLoopThread);
	::ResumeThread(m_hDBDisplayLoopThread);	

	
	
	return;
}


void CSI004Doc::OnTestingSi1300Settings()
{
	
}

void CSI004Doc::OnLiveModeDisplayOn()
{
	m_bDisplay = 1;
}

void CSI004Doc::OnLiveModedisplayOff()
{
	m_bDisplay = 0;
}


DWORD WINAPI CSI004Doc::SnapColorLoopThreadFunc(LPVOID pParam)
{
	CSI004Doc * pDoc = static_cast<CSI004Doc*>(pParam);
	int iBytesRead; 
	int sts;
	DWORD dwStart, dwEnd, TimeArray[20], CountArray[20];
	double TotalSecs;
	
	pDoc->m_dwFrame = 0;
	pDoc->m_Fps = 0.0;
	pDoc->m_BadCount = 0;

	for (int i= 0;  i < 20; i++)
	{
		TimeArray[i] = 0;
		CountArray[i] = 0;
	}
	

	BITMAPINFO * pPackedDIB=NULL;
	
	// Return data pPackedDIBis a pointer to a packed DIB buffer (DIB bits following the header immediately)
	
	POSITION pos = pDoc->GetFirstViewPosition();
				
	CView* pView = pDoc->GetNextView(pos);
	ASSERT(pView->IsKindOf(RUNTIME_CLASS(CSI004View)));
	
	while(pDoc->m_bSnapColorLoopFlag)
	{		
		SI_CaptureDIB(&pDoc->m_CaptureContext);
	
		// update timer variables	
		pDoc->m_dwFrame++;
		TRACE("color loop frame count: %d\n", pDoc->m_dwFrame);
		dwEnd = GetTickCount();
		TotalSecs = ((double)(dwEnd - TimeArray[0]))/1000.0;
		if (pDoc->m_dwFrame > 20)
			pDoc->m_Fps = (1.0 *(pDoc->m_dwFrame - CountArray[0]))/TotalSecs;

		for (int i = 0; i < 19; i++)
		{
			CountArray[i] = CountArray[i + 1];
			TimeArray[i] = TimeArray[i + 1];
		}
		CountArray[19] = pDoc->m_dwFrame;
		TimeArray[19] = dwEnd;

		//if (&m_CaptureContext.PackedDIB)	
		//	//((CSI004View*)pView)->ShowImage(pPackedDIB);
		if (pDoc->m_bDisplay)
			pDoc->ShowImage((const SIPackedDIB *)&pDoc->m_CaptureContext.PackedDIB); 
								
	}

	Sleep(100);
	
	pDoc->ShowImage((const SIPackedDIB *)&pDoc->m_CaptureContext.PackedDIB);
	
	return 0;
}


void CSI004Doc::OnActionStartSnapLoopColor()
{
	if(!InitCapture())
	{
		AfxMessageBox("Image init failed");
		return;
	}

	if (m_bSpecialSettings)
		SetSpecialSettings();
	SI_EndCapture(&m_CaptureContext);

	m_Config.CameraConfig.CAMIFFormat.iWidth = m_Width;
	m_Config.CameraConfig.CAMIFFormat.iHeight = m_Height;

	SI_BeginCapture(&m_Config, &m_CaptureContext );

	if (m_Status == Run)
		return;
	if (m_LiveType != 0)
		return;

	m_LiveType = 5;


	if (m_CamIdent == SI1280 || m_CamIdent == SI6600)
		SI_InitWindowMode(m_iCamID, m_StartRow/m_Subsampling, m_HeightStart/m_Subsampling - 1 + m_StartRow/m_Subsampling, m_StartColumn/m_Subsampling, 
			m_WidthStart/m_Subsampling - 1 + m_StartColumn/m_Subsampling, 0, m_ExposureTime);	

	else
		SI_InitWindowMode(m_iCamID, m_StartRow, m_HeightStart - 1 + m_StartRow, m_StartColumn, m_WidthStart - 1 + m_StartColumn, 0, m_ExposureTime);	

	TRACE("width, height: %d %d\n", m_Width, m_Height);
	TRACE("start row, m_HeightStart, m_StartColumn, m_WidthStart: %d %d %d %d\n", m_StartRow, m_HeightStart, m_StartColumn, m_WidthStart);
	TRACE("clock: %d\n", m_ClockIndex);
	SI_SetClockB(m_iCamID, m_ClockIndex);	
	
	m_bSnapColorLoopFlag = 1;
	
	m_hSnapColorLoopThread = ::CreateThread(NULL,0,SnapColorLoopThreadFunc,this,CREATE_SUSPENDED,NULL);
	    
	m_Status = Run;
		
	::ResumeThread(m_hSnapColorLoopThread);		

	return;
		
}



void CSI004Doc::OnSettingsInvalidCountOn()
{
	m_InvalidShown = 1;
}

void CSI004Doc::OnSettingsInvalidCountOff()
{
	m_InvalidShown = 0;
}

void CSI004Doc::OnTestingSI1300Settings()
{
	
	if(!InitCapture()) return;

	OnActionStopCapture();

	DialogSI1300Settings.m_Width = m_Width * m_Subsampling;
	DialogSI1300Settings.m_Height = m_Height * m_Subsampling;
	DialogSI1300Settings.m_ClockIndex = m_ClockIndex;
	DialogSI1300Settings.m_Exposure = m_ExposureTime;
	DialogSI1300Settings.m_VerticalBlanking;
	DialogSI1300Settings.m_ShutterDelay = m_ShutterDelay;
	DialogSI1300Settings.m_Subsampling = m_Subsampling;
	DialogSI1300Settings.m_StartRow = m_StartRow;	
	DialogSI1300Settings.m_StartColumn = m_StartColumn;
	TRACE("m_ColorMode: %d\n", m_ColorMode);
	DialogSI1300Settings.m_ColorMode = m_ColorMode;		
	DialogSI1300Settings.m_GainMode = m_GainMode;	
	DialogSI1300Settings.m_RedGain = m_RedGain;
	DialogSI1300Settings.m_Green1Gain = m_GreenGain;
	DialogSI1300Settings.m_Green2Gain = m_Green1Gain;		
	DialogSI1300Settings.m_BlueGain = m_BlueGain;
	if (m_Bpp == 8)
		DialogSI1300Settings.m_ColorMode = 0;
	else
		DialogSI1300Settings.m_ColorMode = 1;
	
	if (DialogSI1300Settings.DoModal() == IDOK)
	{	
		m_Width = DialogSI1300Settings.m_Width;
		m_Height = DialogSI1300Settings.m_Height;
		m_WidthStart = m_Width;
		m_HeightStart = m_Height;
		m_ExposureTime = DialogSI1300Settings.m_Exposure;		
		m_ShutterDelay = DialogSI1300Settings.m_ShutterDelay;
		m_Subsampling = DialogSI1300Settings.m_Subsampling;
		m_GlobalGain = DialogSI1300Settings.m_GlobalGain;			
		m_RedGain = DialogSI1300Settings.m_RedGain;
		m_GreenGain = DialogSI1300Settings.m_Green1Gain;
		m_Green1Gain = DialogSI1300Settings.m_Green2Gain;
		m_BlueGain = DialogSI1300Settings.m_BlueGain;
		m_VerticalBlanking = DialogSI1300Settings.m_VerticalBlanking;
		m_ClockIndex = DialogSI1300Settings.m_ClockIndex;
		m_GainMode = DialogSI1300Settings.m_GainMode;	
		m_StartRow = DialogSI1300Settings.m_StartRow;
		m_StartColumn = DialogSI1300Settings.m_StartColumn;
		m_ColorMode = DialogSI1300Settings.m_ColorMode; 
		if (!m_ColorMode)
			m_Bpp = 8;
		else
			m_Bpp = 12;
	}

	m_Camera = SI1300;
	m_bSpecialSettings = TRUE;
}


void CSI004Doc::SetSpecialSettings()
{

	int iVal;
	
	TRACE("m_Camera: %d\n", m_Camera);
		if (m_Camera == 0)
			return;

		else if (m_Camera == SI1280 || m_Camera == SI6600)
		{								
			SI_SetSubsampleMode(m_iCamID, m_Subsampling);				
			m_Width = m_WidthStart/m_Subsampling;
			m_Height = m_HeightStart/m_Subsampling;
			SI_SetExposure(m_iCamID, m_ExposureTime, m_TBRange, m_Exposure);
			SI_SetStartColumn(m_iCamID, m_StartColumn);
			SI_SetStartRow(m_iCamID, m_StartRow);		
			SI_SetGlobalGainB(m_iCamID, m_GlobalGain);			
			SI_SetBlackOffset(m_iCamID, m_BlackLevel);
			SI_SetColumnOffset(m_iCamID, m_ColumnOffset);	
			SI_SetPixelDepth(m_iCamID, m_Bpp);
			
		}

		else if (m_Camera == SI1300)
		{			
			SI_SetVerticalBlanking(m_iCamID, m_VerticalBlanking);
			SI_SetShutterDelay(m_iCamID,  m_ShutterDelay);			
			SI_SetSubsampleMode(m_iCamID, m_Subsampling);	
			m_Width = m_WidthStart/m_Subsampling;
			m_Height = m_HeightStart/m_Subsampling;
			SI_SetStartColumn(m_iCamID, m_StartColumn);
			SI_SetStartRow(m_iCamID, m_StartRow);
			SI_SetPixelDepth(m_iCamID, m_Bpp);
			

			//SI_SetExposureValue(m_iCamID, m_ExposureTime);
			if (!m_GainMode)
			{				
				SI_SetGlobalGainB(m_iCamID, m_GlobalGain);
			}
			else
			{
				SI_SetRGGBGainB(m_iCamID, m_RedGain, m_GreenGain, m_Green1Gain, m_BlueGain);
			}
			
		}
		else if (m_Camera == SI3300)
		{				
			SI_SetVerticalBlanking(m_iCamID, m_VerticalBlanking);			
			SI_SetShutterDelay(m_iCamID,  m_ShutterDelay);			
			SI_SetGlobalShutterMode(m_iCamID,  m_ShutterMode);				
			SI_SetSubsampleMode(m_iCamID, m_Subsampling);	
			m_Width = m_WidthStart/m_Subsampling;
			m_Height = m_HeightStart/m_Subsampling;
			SI_SetStartColumn(m_iCamID, m_StartColumn);
			SI_SetStartRow(m_iCamID, m_StartRow);		
			iVal = m_Width/4;
			if ((4 * iVal) != m_Width)
			m_Width = (iVal + 1) * 4;

			//SI_SetExposureValue(m_iCamID, m_ExposureTime);
			if (!m_GainMode)
				SI_SetGlobalGainB(m_iCamID, m_GlobalGain);
			else
				SI_SetRGGBGainB(m_iCamID, m_RedGain, m_GreenGain, m_Green1Gain, m_BlueGain);

			SI_SetPixelDepth(m_iCamID, m_Bpp);
		}

		else if (m_Camera == SI2100)
		{
			SI_SetVerticalBlanking(m_iCamID, m_VerticalBlanking);				
			SI_SetSubsampleMode(m_iCamID, m_Subsampling);	
			SI_SetAutoModes(m_iCamID, m_AEControl + 3);
			SI_SetStartRow(m_iCamID, m_StartRow);
			SI_SetStartColumn(m_iCamID, m_StartColumn);
			m_Width = m_WidthStart/m_Subsampling;
			m_Height = m_HeightStart/m_Subsampling;
			SI_SetExposureValue(m_iCamID, m_ExposureTime);
			SI_SetPixelDepth(m_iCamID, m_Bpp);
			if (m_AEControl > 0)
				SI_SetAECBrightnessTargets(m_iCamID, m_LowerBrightnessTarget, m_UpperBrightnessTarget);
			TRACE("m_AECcontrol: %d   m_GainMode: %d\n", m_AEControl, m_GainMode);
			if (!m_AEControl)
			{
				TRACE("set RGB gain B %d %d\n",  m_RedGain, m_BlueGain);
				SI_SetGlobalGainB(m_iCamID, m_GlobalGain);
				SI_SetRGBGainB(m_iCamID, m_RedGain, m_GreenGain, m_BlueGain);				
			}
		}

		else if (m_Camera == SI5100)
		{
			SI_SetVerticalBlanking(m_iCamID, m_VerticalBlanking);				
			SI_SetSubsampleMode(m_iCamID, m_Subsampling);	
			SI_SetAutoModes(m_iCamID, m_AEControl + 3);
			SI_SetStartRow(m_iCamID, m_StartRow);
			SI_SetStartColumn(m_iCamID, m_StartColumn);
			m_Width = m_WidthStart/m_Subsampling;
			m_Height = m_HeightStart/m_Subsampling;
			SI_SetExposureValue(m_iCamID, m_ExposureTime);
			SI_SetPixelDepth(m_iCamID, m_Bpp);
			SI_SetImageSizeZoomMode(m_iCamID, m_ImageSize, m_Zoom);
			if (m_AEControl > 0)
				SI_SetAECBrightnessTargets(m_iCamID, m_LowerBrightnessTarget, m_UpperBrightnessTarget);
			TRACE("m_AECcontrol: %d   m_GainMode: %d\n", m_AEControl, m_GainMode);
			if (!m_AEControl)
			{
				TRACE("set RGB gain B %d %d\n",  m_RedGain, m_BlueGain);
				SI_SetGlobalGainB(m_iCamID, m_GlobalGain);
				SI_SetRGBGainB(m_iCamID, m_RedGain, m_GreenGain, m_BlueGain);				
			}
		}

		else if (m_Camera == SI6600)
		{
						
			SI_SetSubsampleMode(m_iCamID, m_Subsampling);				
			m_Width = m_WidthStart/m_Subsampling;
			m_Height = m_HeightStart/m_Subsampling;
			//SI_SetExposureValue(m_iCamID, m_ExposureTime);
			SI_SetStartColumn(m_iCamID, m_StartColumn);
			SI_SetStartRow(m_iCamID, m_StartRow);		
			SI_SetGlobalGainB(m_iCamID, m_GlobalGain);
			SI_SetADC(m_iCamID, m_ADC);
			SI_SetBlackOffset(m_iCamID, m_BlackLevel);
			SI_SetColumnOffset(m_iCamID, m_ColumnOffset);					
		}
		else
			return;

}

void CSI004Doc::OnTestingSI2100Settings()
{

	if(!InitCapture()) return;

	OnActionStopCapture();

	if (m_Width == UXGA_WIDTH)
	{
		DialogSI2100Settings.m_ImageSize = 0;		
	}
	else if (m_Width == SVGA_WIDTH)
	{
		DialogSI2100Settings.m_ImageSize = 1;		
	}
	else
		DialogSI2100Settings.m_ImageSize = 0;

	DialogSI2100Settings.m_ClockIndex = m_ClockIndex;
	DialogSI2100Settings.m_Exposure = m_ExposureTime;
	DialogSI2100Settings.m_GlobalGain = m_GlobalGain;	
	DialogSI2100Settings.m_Subsampling = m_Subsampling;
	DialogSI2100Settings.m_VertBlanking = m_VerticalBlanking;
	DialogSI2100Settings.m_UpperBrightnessTarget = m_UpperBrightnessTarget;
	DialogSI2100Settings.m_LowerBrightnessTarget = m_LowerBrightnessTarget;
	DialogSI2100Settings.m_AEControl = m_AEControl;
	DialogSI2100Settings.m_ColorMode = m_ColorMode;	
	DialogSI2100Settings.m_RedGain = m_RedGain;
	DialogSI2100Settings.m_BlueGain = m_BlueGain ;
	if (m_Bpp == 8)
		DialogSI2100Settings.m_ColorMode = 0;
	else
		DialogSI2100Settings.m_ColorMode = 1;
	
	if (DialogSI2100Settings.DoModal() == IDOK)
	{	
		m_Width = DialogSI2100Settings.m_Width;
		m_Height = DialogSI2100Settings.m_Height;
		m_WidthStart = m_Width;
		m_HeightStart = m_Height;		
		m_VerticalBlanking = DialogSI2100Settings.m_VertBlanking;	
		m_ExposureTime = DialogSI2100Settings.m_Exposure;				
		m_AEControl =   DialogSI2100Settings.m_AEControl;
		m_ClockIndex = DialogSI2100Settings.m_ClockIndex;
		m_GlobalGain = DialogSI2100Settings.m_GlobalGain;		
		m_RedGain = DialogSI2100Settings.m_RedGain;
		m_BlueGain = DialogSI2100Settings.m_BlueGain;
		m_UpperBrightnessTarget = DialogSI2100Settings.m_UpperBrightnessTarget;
		m_LowerBrightnessTarget = DialogSI2100Settings.m_LowerBrightnessTarget;
		m_ColorMode = DialogSI2100Settings.m_ColorMode;	
		if (!m_ColorMode)
			m_Bpp = 8;
		else
			m_Bpp = 12;	
	}

	m_Camera = SI2100;
	if (m_Width == UXGA_WIDTH)
		{			
			DialogSI2100Settings.m_Subsampling = 1;
		}
		else
		{
			DialogSI2100Settings.m_Subsampling = 2;
		}
	m_bSpecialSettings = TRUE;
}

void CSI004Doc::OnTestingSI5100Settings()
{
	if(!InitCapture()) return;

	OnActionStopCapture();

	if (m_Width == QSXGA_WIDTH)
		DialogSI5100Settings.m_ImageSize = 0;
	else if (m_Width == SXGA_WIDTH)
		DialogSI5100Settings.m_ImageSize = 1;
	else if (m_Width == VGA_WIDTH)
		DialogSI5100Settings.m_ImageSize = 2;
	else if (m_Width == HF_WIDTH)
		DialogSI5100Settings.m_ImageSize = 3;

	DialogSI5100Settings.m_Zoom = m_Zoom;

	DialogSI5100Settings.m_ClockIndex = m_ClockIndex;
	DialogSI5100Settings.m_Exposure = m_ExposureTime;
	DialogSI5100Settings.m_GlobalGain = m_GlobalGain;		
	DialogSI5100Settings.m_VerticalBlanking = m_VerticalBlanking;
	DialogSI5100Settings.m_UpperBrightnessTarget = m_UpperBrightnessTarget;
	DialogSI5100Settings.m_LowerBrightnessTarget = m_LowerBrightnessTarget;
	DialogSI5100Settings.m_AEControl = m_AEControl;
	DialogSI5100Settings.m_ColorMode = m_ColorMode;	
	DialogSI5100Settings.m_RedGain = m_RedGain;
	DialogSI5100Settings.m_BlueGain = m_BlueGain ;
	
	if (m_Bpp == 8)
		DialogSI5100Settings.m_ColorMode = 0;
	else
		DialogSI5100Settings.m_ColorMode = 1;
	
	if (DialogSI5100Settings.DoModal() == IDOK)
	{	
		m_Width = DialogSI5100Settings.m_Width;
		m_Height = DialogSI5100Settings.m_Height;
		m_ImageSize = DialogSI5100Settings.m_ImageSize;
		
		TRACE("5100: m_Width: %d  m_Height: %d\n", m_Width, m_Height);
		m_WidthStart = m_Width;
		m_HeightStart = m_Height;		
		m_VerticalBlanking = DialogSI5100Settings.m_VerticalBlanking;	
		m_ExposureTime = DialogSI5100Settings.m_Exposure;				
		m_AEControl =   DialogSI5100Settings.m_AEControl;
		m_ClockIndex = DialogSI5100Settings.m_ClockIndex;
		m_GlobalGain = DialogSI5100Settings.m_GlobalGain;		
		m_RedGain = DialogSI5100Settings.m_RedGain;
		m_BlueGain = DialogSI5100Settings.m_BlueGain;
		m_UpperBrightnessTarget = DialogSI5100Settings.m_UpperBrightnessTarget;
		m_LowerBrightnessTarget = DialogSI5100Settings.m_LowerBrightnessTarget;
		m_ColorMode = DialogSI5100Settings.m_ColorMode;	
		if (!m_ColorMode)
			m_Bpp = 8;
		else
			m_Bpp = 12;	
		m_Zoom = DialogSI5100Settings.m_Zoom;
		
	}

	m_Camera = SI5100;
	m_Subsampling = 1;
	m_bSpecialSettings = TRUE;

}

void CSI004Doc::OnTestingSI3300Settings()
{
	int val;

	if(!InitCapture()) return;

	OnActionStopCapture();

	DialogSI3300Settings.m_Width = m_Width * m_Subsampling;
	DialogSI3300Settings.m_Height = m_Height * m_Subsampling;
	DialogSI3300Settings.m_ClockIndex = m_ClockIndex;
	DialogSI3300Settings.m_GlobalGain = m_GlobalGain;
	DialogSI3300Settings.m_ShutterDelay = m_ShutterDelay;
	DialogSI3300Settings.m_Subsampling = m_Subsampling;
	DialogSI3300Settings.m_Exposure = m_ExposureTime;
	DialogSI3300Settings.m_VertBlanking = m_VerticalBlanking;
	DialogSI3300Settings.m_ColorMode = m_ColorMode;
	DialogSI3300Settings.m_GainMode = m_GainMode;	
	DialogSI3300Settings.m_RedGain = m_RedGain;
	DialogSI3300Settings.m_Green1Gain = m_GreenGain;
	DialogSI3300Settings.m_Green2Gain = m_Green1Gain;		
	DialogSI3300Settings.m_BlueGain = m_BlueGain;
	DialogSI3300Settings.m_ShutterMode = m_ShutterMode;
	if (m_Bpp == 8)
		DialogSI3300Settings.m_ColorMode = 0;
	else
		DialogSI3300Settings.m_ColorMode = 1;
	
	
	if (DialogSI3300Settings.DoModal() == IDOK)
	{	
		m_Width = DialogSI3300Settings.m_Width;;
		m_Height = DialogSI3300Settings.m_Height;
		m_WidthStart = m_Width;
		m_HeightStart = m_Height;
		m_ExposureTime = DialogSI3300Settings.m_Exposure;		
		m_ShutterDelay = DialogSI3300Settings.m_ShutterDelay;
		m_Subsampling = DialogSI3300Settings.m_Subsampling;
		m_StartColumn = DialogSI3300Settings.m_StartColumn;
		m_StartRow = DialogSI3300Settings.m_StartRow;
		m_ColorMode = DialogSI3300Settings.m_ColorMode;
		m_ShutterMode = DialogSI3300Settings.m_ShutterMode;
		
		
		if ((m_SubsamplingB & 0x07) == 0)
			m_Subsampling = 1;
		else if ((m_SubsamplingB & 0x07) == 1)
			m_Subsampling = 2;
		else if ((m_SubsamplingB & 0x07) == 2)
			m_Subsampling = 3;
		else if ((m_SubsamplingB & 0x07) == 3)
			m_Subsampling = 4;
		else if ((m_SubsamplingB & 0x07) == 4)
			m_Subsampling = 8;

				
		m_GlobalGain = DialogSI3300Settings.m_GlobalGain;			
		m_RedGain = DialogSI3300Settings.m_RedGain;
		m_GreenGain = DialogSI3300Settings.m_Green1Gain;
		m_Green1Gain = DialogSI3300Settings.m_Green2Gain;		
		m_BlueGain = DialogSI3300Settings.m_BlueGain;
		m_VerticalBlanking = DialogSI3300Settings.m_VertBlanking;
		m_ClockIndex = DialogSI3300Settings.m_ClockIndex;
		m_GainMode = DialogSI3300Settings.m_GainMode;
		m_ColorMode = DialogSI3300Settings.m_ColorMode;
		if (!m_ColorMode)
			m_Bpp = 8;
		else
			m_Bpp = 12;	
	}

	m_Camera = SI3300;
	m_bSpecialSettings = TRUE;
}

void CSI004Doc::OnTestingSI6600Settings()
{	
	if(!InitCapture()) return;

	OnActionStopCapture();

	DialogSI6600Settings.m_Width = m_Width * m_Subsampling;
	DialogSI6600Settings.m_Height = m_Height * m_Subsampling;
	DialogSI6600Settings.m_ClockIndex = m_ClockIndex;
	DialogSI6600Settings.m_Exposure = m_ExposureTime;
	DialogSI6600Settings.m_BlackLevel = m_BlackLevel;
	DialogSI6600Settings.m_StartColumn = m_StartColumn;
	DialogSI6600Settings.m_StartRow = m_StartRow;
	DialogSI6600Settings.m_ColumnOffset = m_ColumnOffset;
	DialogSI6600Settings.m_GlobalGain = m_GlobalGain;
	DialogSI6600Settings.m_ColorMode = m_ColorMode;
	if (m_Bpp == 8)
		DialogSI6600Settings.m_ColorMode = 0;
	else
		DialogSI6600Settings.m_ColorMode = 1;
	

	if (DialogSI6600Settings.DoModal() == IDOK)
	{	
	m_Width = DialogSI6600Settings.m_Width;
	m_Height = DialogSI6600Settings.m_Height;
	m_WidthStart = m_Width;
	m_HeightStart = m_Height;					
	m_ExposureTime = DialogSI6600Settings.m_Exposure;		
	m_Subsampling = DialogSI6600Settings.m_Subsampling;
	m_StartColumn = DialogSI6600Settings.m_StartColumn;
	m_StartRow = DialogSI6600Settings.m_StartRow;
	m_ClockIndex = DialogSI6600Settings.m_ClockIndex;
	m_GlobalGain = DialogSI6600Settings.m_GlobalGain;
	m_BlackLevel = DialogSI6600Settings.m_BlackLevel;
	m_ADC = DialogSI6600Settings.m_ADC;
	m_ColumnOffset = DialogSI6600Settings.m_ColumnOffset;
	m_ColorMode = DialogSI6600Settings.m_ColorMode; 
	if (!m_ColorMode)
		m_Bpp = 8;
	else
		m_Bpp = 12;
	}

	m_Camera = SI6600;
	m_bSpecialSettings = TRUE;
	//RedrawDisplay();
}

void CSI004Doc::GetCameraFirmwareSerialNumber()
{
	
	if(!InitCapture()) return;
		
	DialogCamInfo.cCamType = m_cCamType;
	DialogCamInfo.cCamVersion = m_cCamVersion;
	DialogCamInfo.cCamSerialNumber = m_cCamSerialNumber;

	// display camera info dialog box
	DialogCamInfo.DoModal();
	
}

void CSI004Doc::OnActionSnap12BitMonoSave()
{
	int ret, iBytesRead;
	char mbuf[64];
	SIMonoImage ImgData;
	char FilenameB[20] = "image.bin";

	if (m_LiveType != 0)
		return;
	
	if(!InitCapture()) return;

	if (m_bSpecialSettings)
		SetSpecialSettings();	

	//m_Width = 1024;
	//m_Height = 1024;


	int iSize = 2 * m_Width * m_Height;
	pDBuffer2 = new BYTE[iSize];
	
	ImgData.iWidth = 2 * m_Width;
	ImgData.iHeight = m_Height;
	ImgData.iPitch = 1;
	ImgData.iBpp = 16;
	ImgData.Data.pData8u = (unsigned char*)pDBuffer2;

	BITMAPINFOHEADER * pBmi = (BITMAPINFOHEADER*)(new BYTE[sizeof(BITMAPINFOHEADER) + 256*sizeof(RGBQUAD) + iSize]);
	ZeroMemory(pBmi,sizeof(BITMAPINFOHEADER));
	pBmi->biSize					= sizeof(BITMAPINFOHEADER);
	pBmi->biWidth					= m_Width;
	pBmi->biHeight				=	m_Height;
	pBmi->biPlanes				= 1;
	pBmi->biBitCount			= 16;			
	pBmi->biCompression	= BI_RGB;	

	//RGBQUAD * pQuad = (RGBQUAD*)(reinterpret_cast<BYTE*>(pBmi) + sizeof(BITMAPINFOHEADER));	
	//BYTE * pDBuffer2 = (PBYTE)(reinterpret_cast<BYTE*>(pBmi) + sizeof(BITMAPINFOHEADER) + 256*sizeof(RGBQUAD));	

	//for(int i=0; i<256; i++)
	//{
	//	pQuad->rgbBlue = pQuad->rgbGreen = pQuad->rgbRed = i;
	//	pQuad->rgbReserved = 0;
	//	pQuad++;
	//}

	m_dwFrame = 0;		
    m_Fps = 0;
	m_BadCount = 0;
				
	if (m_CamIdent == SI1280 || m_CamIdent == SI6600)
		SI_InitWindowMode(m_iCamID, m_StartRow/m_Subsampling, m_HeightStart/m_Subsampling - 1 + m_StartRow/m_Subsampling, m_StartColumn/m_Subsampling, 
			m_WidthStart/m_Subsampling - 1 + m_StartColumn/m_Subsampling, 0, m_ExposureTime);	

	else
		SI_InitWindowMode(m_iCamID, m_StartRow, m_HeightStart - 1 + m_StartRow, m_StartColumn, m_WidthStart - 1 + m_StartColumn, 0, m_ExposureTime);	


	SI_SetPixelDepth(m_iCamID, 12);
	
	SI_SetClockB(m_iCamID, m_ClockIndex-3);
		
	ret = SI_SnapBulkImage(m_iCamID, m_Width, m_Height, 12, pDBuffer2, &iBytesRead);
	if (ret != SI_STATUS_SUCCESS)
	{
		//AfxMessageBox("snap failed");
		return;
	}

	
		
	
	//POSITION pos = GetFirstViewPosition();
    //if(pos != NULL)
	//	{			
	//		CView* pView = GetNextView(pos);									
	//		ASSERT(pView->IsKindOf(RUNTIME_CLASS(CSI004View)));
	//		((CSI004View*)pView)->Display(reinterpret_cast<BITMAPINFO*>(pBmi),pDBuffer2);							
  	//	}

	//pBmi->biHeight	=	-m_Height;
		
	ret = SI_SaveBinFileB(pDBuffer2, iSize, FilenameB);
	
	SI_SetPixelDepth(m_iCamID, 8);
		
	delete [] pBmi;
	//delete [] pDBuffer2;
}

void CSI004Doc::OnActionStopCapture()
{
	
	if (m_Status == Run && m_LiveType == 1)
	{
		m_bSnapLoopFlag = 0;
		if (m_bTriggeredSnapLoop)
		{
			OnActionDisarmTrigger();
			m_bTriggeredSnapLoop = FALSE;
		}
		else	
			::CloseHandle(m_hSnapLoopThread);

		m_Status = Stop;
		m_LiveType = 0;
	}

	if (m_LiveType == 2)
	{
		m_bDBSnapFlag = 0;
		Sleep(500);
		
		m_Status = Stop;
		m_LiveType = 0;
	}

	if (m_LiveType == 3)
	{
		SI_SnapBulkLiveStop(m_iCamID);
		m_bStopLiveFlag = 1;
		m_Status = Stop;		
		m_LiveType = 0;
						
		::CloseHandle(m_hEvent1);
		::CloseHandle(m_hEvent2);
		::CloseHandle(m_hEvent3);
		::CloseHandle(m_hLiveThread);
		::CloseHandle(m_hLiveDisplayThread);
	}

	if (m_LiveType == 5)
	{
		m_bSnapColorLoopFlag = 0;		
		::CloseHandle(m_hSnapColorLoopThread);

		m_Status = Stop;
		m_LiveType = 0;

	}

	if (m_LiveType == 6)
	{
		m_bDisplaySequence = FALSE;		
		m_Status = Stop;
		m_LiveType = 0;
	}

	if (m_bCaptureSequenceBuffer)
	{
		delete [] pBuffer;
		::CloseHandle(m_hEvent1);
		::CloseHandle(m_hEvent3);
				
		::CloseHandle(m_hLiveSeqThread);		
		::CloseHandle(m_hLiveSeqDisplayThread);
	}
	
}

void CSI004Doc::OnTestingSI1280Settings()
{
if(!InitCapture()) return;

	OnActionStopCapture();

	DialogSI1280Settings.m_Width = m_Width * m_Subsampling;
	DialogSI1280Settings.m_Height = m_Height * m_Subsampling;
	DialogSI1280Settings.m_ClockIndex = m_ClockIndex;
	DialogSI1280Settings.m_Exposure = m_ExposureTime;
	DialogSI1280Settings.m_BlackLevel = m_BlackLevel;
	DialogSI1280Settings.m_ColumnOffset = m_ColumnOffset;
	DialogSI1280Settings.m_ShutterMode = m_ShutterMode;
	//DialogSI1280Settings.m_Count = m_Count;
	DialogSI1280Settings.m_TBRange = m_TBRange;
	DialogSI1280Settings.m_GlobalGain = m_GlobalGain;
	DialogSI1280Settings.m_Subsampling = m_Subsampling;
	DialogSI1280Settings.m_StartColumn = m_StartColumn;
	DialogSI1280Settings.m_StartRow = m_StartRow;
	if (m_Bpp == 8)
		DialogSI1280Settings.m_ColorMode = 0;
	else
		DialogSI1280Settings.m_ColorMode = 1;


	if (DialogSI1280Settings.DoModal() == IDOK)
	{	
		m_Width = DialogSI1280Settings.m_Width;
		m_Height = DialogSI1280Settings.m_Height;
		m_WidthStart = m_Width;
		m_HeightStart = m_Height;					
		m_ExposureTime = DialogSI1280Settings.m_Exposure;	
		m_TBRange = DialogSI1280Settings.m_TBRange;
		m_Subsampling = DialogSI1280Settings.m_Subsampling;
		m_StartColumn = DialogSI1280Settings.m_StartColumn;
		m_StartRow = DialogSI1280Settings.m_StartRow;
		m_ClockIndex = DialogSI1280Settings.m_ClockIndex;
		m_GlobalGain = DialogSI1280Settings.m_GlobalGain;
		m_BlackLevel = DialogSI1280Settings.m_BlackLevel;
		m_ShutterMode = DialogSI1280Settings.m_ShutterMode;
		m_ColumnOffset = DialogSI1280Settings.m_ColumnOffset;
		//m_Count = DialogSI1280Settings.m_Count;	
		if (DialogSI1280Settings.m_ColorMode)
			m_Bpp = 12;
		else
			m_Bpp = 8;
	}

	m_Camera = SI1280;
	m_bSpecialSettings = TRUE;
}


void CSI004Doc::RedrawDisplay()
{
//	POSITION pos = GetFirstViewPosition();
//	if (pos != NULL)
//	{			
//		CView* pView = GetNextView(pos);
//		((CSI004View*)pView)->Display(reinterpret_cast<BITMAPINFO*>(m_pBmi),pDBuffer2 + (m_Width * m_Height));				

//	}
}
void CSI004Doc::OnPixelCorrectionOn()
{
	m_DPCOn = 1;
	
}

void CSI004Doc::OnPixelCorrectionOff()
{
	m_DPCOn = 0;
}


DWORD WINAPI CSI004Doc::ArmSnapThreadFunc(LPVOID pParam)
{
	CSI004Doc * pDoc = static_cast<CSI004Doc*>(pParam);
	int iBytesRead; 
	int sts, iDepth, ret;
	char mbuf[64];

	int iSize = pDoc->m_Width * pDoc->m_Height;
	pDoc->pDBuffer2 = new BYTE[iSize];

	TRACE("in arm thread\n");
	BITMAPINFOHEADER * pBmi = (BITMAPINFOHEADER*)(new BYTE[sizeof(BITMAPINFOHEADER) + 256*sizeof(RGBQUAD) + iSize]);
	ZeroMemory(pBmi,sizeof(BITMAPINFOHEADER));
	pBmi->biSize					= sizeof(BITMAPINFOHEADER);
	pBmi->biWidth					= pDoc->m_Width;
	pBmi->biHeight				=	pDoc->m_Height;
	pBmi->biPlanes				= 1;
	pBmi->biBitCount			= 8;			
	pBmi->biCompression	= BI_RGB;	

	RGBQUAD * pQuad = (RGBQUAD*)(reinterpret_cast<BYTE*>(pBmi) + sizeof(BITMAPINFOHEADER));	

	for(int i=0; i<256; i++)
	{
		pQuad->rgbBlue = pQuad->rgbGreen = pQuad->rgbRed = i;
		pQuad->rgbReserved = 0;
		pQuad++;
	}
	pDoc->m_dwFrame = 0;
	pDoc->m_Fps = 0.0;

	StartArmLoop:;
	//AfxMessageBox("starting arm");
	SI_ArmTriggerWait(pDoc->m_iCamID);

	ret = SI_SnapBulkImage(pDoc->m_iCamID, pDoc->m_Width, pDoc->m_Height, 8, pDoc->pDBuffer2, &iBytesRead);
	if (ret != SI_STATUS_SUCCESS)
	{		
		pDoc->m_LiveType = 0;
		pDoc->m_bTriggeredSnapLoop = FALSE;
		pDoc->m_Status = Stop;
		return 0;		
	}

	
	POSITION pos = pDoc->GetFirstViewPosition();
    if(pos != NULL)
		{			
			CView* pView = pDoc->GetNextView(pos);									
			ASSERT(pView->IsKindOf(RUNTIME_CLASS(CSI004View)));
			((CSI004View*)pView)->Display(reinterpret_cast<BITMAPINFO*>(pBmi),pDoc->pDBuffer2);							
  		}
		TRACE("snaploopflag: %d  triggeredsnaploopflag: %d\n", pDoc->m_bSnapLoopFlag , pDoc->m_bTriggeredSnapLoop);
	//if (!pDoc->m_bSnapLoopFlag || !pDoc->m_bTriggeredSnapLoop)
	//{
	//	sprintf(mbuf, "loop flag: %d  trigger flag: %d",pDoc->m_bSnapLoopFlag, pDoc->m_bTriggeredSnapLoop);
	//	AfxMessageBox(mbuf);
	//}

	if (pDoc->m_bSnapLoopFlag && pDoc->m_bTriggeredSnapLoop)
		goto StartArmLoop;

	//Sleep(500);
	endarm:;
	delete [] pDoc->pDBuffer2;
	delete [] pBmi;
	
	pDoc->m_bTriggeredSnapLoop = FALSE;
	pDoc->OnActionStopCapture();
	
	//Sleep(2000);			
	return 0;
}


void CSI004Doc::OnActionArmSnap()
{

	int iSize;
	
	if (m_LiveType >  1)
		return;
	
	if(!InitCapture()) return;
	
	if (m_bSpecialSettings)
		SetSpecialSettings();

	iSize = m_Width * m_Height;	
		
	if (m_CamIdent == SI1280 || m_CamIdent == SI6600)
		SI_InitWindowMode(m_iCamID, m_StartRow/m_Subsampling, m_HeightStart/m_Subsampling - 1 + m_StartRow/m_Subsampling, m_StartColumn/m_Subsampling, 
			m_WidthStart/m_Subsampling - 1 + m_StartColumn/m_Subsampling, 0, m_ExposureTime);	

	else
	{
		SI_InitWindowMode(m_iCamID, m_StartRow, m_HeightStart - 1 + m_StartRow, m_StartColumn, m_WidthStart - 1 + m_StartColumn, 0, m_ExposureTime);	
	}
				
	SI_SetClockB(m_iCamID, m_ClockIndex);
					
	m_hArmSnapThread = ::CreateThread(NULL,0,ArmSnapThreadFunc,this, 0 ,NULL);
	CloseHandle(m_hArmSnapThread);
	
	return;
}

void CSI004Doc::OnActionDisarmTrigger()
{
	m_hDisarmThread = ::CreateThread(NULL,0,DisarmThreadFunc,this,0 ,NULL);	    		
	//::ResumeThread(DisarmThreadFunc);	
}

CSI004Doc* CSI004Doc::GetDoc()
{
     CFrameWnd * pFrame = (CFrameWnd *)(AfxGetApp()->m_pMainWnd);
     return (CSI004Doc *) pFrame->GetActiveDocument();
}


void CSI004Doc::OnActionSetBMPSaveFilename()
{	
	TCHAR szFilters[] = _T("Bmp Files (*.bmp)|*.bmp|All files (*.*)|*.*||");
	CFileDialog dlg(FALSE,"bmp",NULL,OFN_OVERWRITEPROMPT,szFilters);
	if(dlg.DoModal() == IDOK)
	{
		m_Filename = dlg.GetPathName();
		m_SaveFlag = TRUE;
	}
}



void CSI004Doc::OnActionLiveStartColor()
{
	m_ColorFlag = 1;
	OnActionLiveStart();
}


	
void CSI004Doc::OnActionStartLiveAsyncDemo()
{
	m_PanScrollFlag = 1;
	//SI_SetAsyncControlMode(0, TRUE);
	OnActionLiveStart();
}
	

void CSI004Doc::OnSettingsSetCameraNumber()
{
if (DialogCamNumber.DoModal() == IDOK)
	{	
		m_iCamID = DialogCamNumber.m_iCamID;
		
	}

}

void CSI004Doc::OnRead2100Registers()
{
	unsigned char reg;
	CString str = "0x";
	int ret;

	if(!InitCapture()) return;

	ret = SI_TransferControlData(m_iCamID, 0xD0,  0, 0, 1, 1, &reg);		
	str.Format(_T("0x%x"), reg);   
	Dialog2100Regs.RegGain = str;

	SI_TransferControlData(m_iCamID, 0xD0,  1, 0, 1, 1, &reg);
	str.Format(_T("0x%x"), reg);   
	Dialog2100Regs.RegBlue = str;
	
	SI_TransferControlData(m_iCamID, 0xD0,  2, 0, 1, 1, &reg);
	str.Format(_T("0x%x"), reg);   
	Dialog2100Regs.RegRed = str;
	
	SI_TransferControlData(m_iCamID, 0xD0,  3, 0, 1, 1, &reg);
	str.Format(_T("0x%x"), reg);   
	Dialog2100Regs.RegComa = str;
	
	SI_TransferControlData(m_iCamID, 0xD0,  4, 0, 1, 1, &reg);
	str.Format(_T("0x%x"), reg);   
	Dialog2100Regs.RegComb = str;
	
	SI_TransferControlData(m_iCamID, 0xD0,  5, 0, 1, 1, &reg);
	str.Format(_T("0x%x"), reg);   
	Dialog2100Regs.RegBavg = str;
	
	SI_TransferControlData(m_iCamID, 0xD0,  6, 0, 1, 1, &reg);
	str.Format(_T("0x%x"), reg);   
	Dialog2100Regs.RegGbavg = str;
	
	SI_TransferControlData(m_iCamID, 0xD0,  7, 0, 1, 1, &reg);
	str.Format(_T("0x%x"), reg);   
	Dialog2100Regs.RegGravg = str;
	
	SI_TransferControlData(m_iCamID, 0xD0,  8, 0, 1, 1, &reg);
	str.Format(_T("0x%x"), reg);   
	Dialog2100Regs.RegRavg = str;
	
	SI_TransferControlData(m_iCamID, 0xD0,  16, 0, 1, 1, &reg);
	str.Format(_T("0x%x"), reg);   
	Dialog2100Regs.RegAec = str;
	
	SI_TransferControlData(m_iCamID, 0xD0,  18, 0, 1, 1, &reg);
	str.Format(_T("0x%x"), reg);   
	Dialog2100Regs.RegComh = str;
	
	SI_TransferControlData(m_iCamID, 0xD0,  19, 0, 1, 1, &reg);
	str.Format(_T("0x%x"), reg);   
	Dialog2100Regs.RegComi = str;
	
	SI_TransferControlData(m_iCamID, 0xD0,  44, 0, 1, 1, &reg);
	str.Format(_T("0x%x"), reg);   
	Dialog2100Regs.RegAddvsl = str;
	
	Dialog2100Regs.DoModal();
}

void CSI004Doc::OnSettingsSetDriverDelay()
{	
	if(!InitCapture()) return;
	DialogDriverDelay.m_DriverDelay = m_DriverDelay;
	if (DialogDriverDelay.DoModal() == IDOK)
	{	
		m_DriverDelay = DialogDriverDelay.m_DriverDelay;
		SI_SetDriverDelay(m_iCamID, m_DriverDelay); 
	}

}

void CSI004Doc::OnActionTestHandle()
{

	SI_ReadConfig(m_strConfigFile,&m_Config, SIGenericCam);
	//AfxMessageBox("readconfig passed");;
		
	if(SI_BeginCapture(&m_Config, &m_CaptureContext ) != SR_OK)
	{		
		AfxMessageBox("camera init failed\n");
		return;
	}

	//AfxMessageBox("begincapture passed");

	SI_EndCapture(&m_CaptureContext);

	//AfxMessageBox("end capture passed");
}


void CSI004Doc::OnGetCameraType()
{
	char pcDriverName[8]   = "Ezusb-0";
	
	int ret = SI_OpenCamera(m_iCamID, pcDriverName);

	if (ret != SI_STATUS_SUCCESS)
		AfxMessageBox("open camera failed");

	SI_ReadSerialNumber(m_iCamID, m_cCamSerialNumber);

	// determine camera firmware version and type
	SI_ReadVersion(m_iCamID, m_cCamVersion);
	m_cCamType[0] = 'S';
	m_cCamType[1] = 'I';
	m_cCamType[2] = '-';
	m_cCamType[5] = '0';
	m_cCamType[6] = '0';
	m_cCamType[7] = '\0';

	if (m_cCamVersion[1] == 'y')
	{
		m_cCamType[3] = '3';
		m_cCamType[4] = '1';
		m_cCamType[4] = '7';
		m_CamIdent = SI3170C;
		m_TypeCount[SI3170C]++;
	}
	else if (m_cCamVersion[1] =='f') 
	{
		m_cCamType[3] = '1';
		m_cCamType[4] = '2';
		m_cCamType[5] = '8';
		m_CamIdent = SI1280C;
		m_TypeCount[SI1280C]++;
	}	
		
	else if (m_cCamVersion[1] == 'o')
	{
		m_cCamType[3] = '2';
		m_cCamType[4] = '1';
		m_CamIdent = SI2100C;
		m_TypeCount[SI2100C]++;
	}		
	else if (m_cCamVersion[0] == 's' &&  m_cCamVersion[1] == 'm') 
	{
		m_cCamType[3] = '1';
		m_cCamType[4] = '3';
		m_CamIdent = SI1300C;
		m_TypeCount[SI1300C]++;
	}		
	else if (m_cCamVersion[0] == 's'  && m_cCamVersion[1] == 't' )
	{
		m_cCamType[3] = '3';
		m_cCamType[4] = '3';
		m_CamIdent = SI3300C;
	}		
	else if (m_cCamVersion[0] == 'u'  && m_cCamVersion[1] == 'i' )
	{
		m_cCamType[3] = '6';
		m_cCamType[4] = '6';
		m_CamIdent = SI6600C;
		m_TypeCount[SI6600C]++;
	}
	else if (m_cCamVersion[0] == 'u'  && m_cCamVersion[1] == 'q' )
	{
		m_cCamType[3] = '5';
		m_cCamType[4] = '1';
		m_CamIdent = SI5100C;
		m_TypeCount[SI5100C]++;
	}	

	SI_CloseCamera(m_iCamID);
	
	return;

}

void CSI004Doc::OnActionStartTriggeredSnapLoop()
{
	m_bTriggeredSnapLoop = TRUE;
	m_bSnapLoopFlag = TRUE;
	m_Status = Run;
	m_LiveType = 1;
	OnActionArmSnap();
}



void CSI004Doc::OnSettingsSetAutoexposure()
{
	CFrameWnd * pFrame = (CFrameWnd *)(AfxGetApp()->m_pMainWnd);
	if (m_AutoExposure)
	{
		m_AutoExposure = FALSE;
		CMenu* menu = pFrame->GetMenu();
		CMenu* submenu = menu->GetSubMenu(5);
		submenu->CheckMenuItem(ID_SETTINGS_AUTOEXPOSUREENABLED, MF_UNCHECKED | MF_BYCOMMAND);		
	}
	else
	{
		m_AutoExposure = TRUE;
		CMenu* menu = pFrame->GetMenu();
		CMenu* submenu = menu->GetSubMenu(5);
		submenu->CheckMenuItem(ID_SETTINGS_AUTOEXPOSUREENABLED, MF_CHECKED | MF_BYCOMMAND);		
	}

}

void CSI004Doc::OnSettingsDisplaySubsamplingEnabled()
{
	CFrameWnd * pFrame = (CFrameWnd *)(AfxGetApp()->m_pMainWnd);
	if (m_DisplaySubsamp >  1)
	{
		m_DisplaySubsamp = 1;
		//AfxMessageBox("disp subsamp setting to 1");
		CMenu* menu = pFrame->GetMenu();
		CMenu* submenu = menu->GetSubMenu(5);
		submenu->CheckMenuItem(ID_SETTINGS_DISPLAYSUBSAMPLINGENABLED, MF_UNCHECKED | MF_BYCOMMAND);		
	}
	else
	{
		m_DisplaySubsamp = 2;
		//AfxMessageBox("disp subsamp set to 2");
		CMenu* menu = pFrame->GetMenu();
		CMenu* submenu = menu->GetSubMenu(5);
		submenu->CheckMenuItem(ID_SETTINGS_DISPLAYSUBSAMPLINGENABLED, MF_CHECKED | MF_BYCOMMAND);		
	}

 }


